﻿using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using SMSObjMgrLib;

namespace SMSTest
{
    public partial class SMSTest : Form, ISMSCallBack
    {
        private SMSObjectsManager manager = null;
        // Конкретный экземтляр
        //private ISMSObject smsObject = null;
        //private bool isConnected = false;
        // СМС индекс
        private int nMsgId = 255;
        private ISMSObject smsObject = null;

        private static Action<TextBox, string> _setText = delegate(TextBox textBox, string text) { textBox.Text = text; };

        public SMSTest()
        {
            InitializeComponent();

            //this.buttonSend.Enabled = false;
        }

        private void SMSTest_Load(object sender, EventArgs e)
        {
            this.manager = new SMSObjectsManager();
        }

        private void SMSTest_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (this.smsObject != null)
            {
                this.smsObject.UnAdvise();
                this.smsObject = null;
            }
        }

        /// <summary>
        /// Соединение с конкретным объектом
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //private void buttonConnect_Click(object sender, EventArgs e)
        //{
        //    if (!this.isConnected)
        //    {
        //        if (string.IsNullOrEmpty(this.textBoxSMSName.Text))
        //        {
        //            MessageBox.Show("Enter TitleObject name.");
        //            return;
        //        }
        //        try
        //        {
        //            smsObject = manager.GetSMSObjectByName(this.textBoxSMSName.Text) as ISMSObject;
        //        }
        //        catch (System.ArgumentException ex)
        //        {
        //            MessageBox.Show(string.Format("TitleObject with name '{0}' not found or not started.", this.textBoxSMSName.Text));
        //            return;
        //        }
        //        this.buttonSend.Enabled = true;
        //        this.buttonConnect.Text = "Disconnect";
        //        this.isConnected = true;
        //    }
        //    else
        //    {
        //        this.buttonSend.Enabled = false;
        //        this.buttonConnect.Text = "Connect";
        //        this.isConnected = false;
        //    }
        //}

        /// <summary>
        /// COMException ex: HRESULT = E_FAIL - нет запущенных СМС объектов
        ///                          = E_PENDING - все СМС объекты заняты
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSend_Click(object sender, EventArgs e)
        {
            try
            {
                if (this.smsObject == null)
                {
                    this.smsObject = manager.GetSMSObjectByName(this.textBoxSMSName.Text) as ISMSObject;
                    if (this.smsObject != null)
                        this.smsObject.Advise(this);
                }

                this.manager.SetStyleMessageTo(this.textBoxSMSName.Text, "0", this.textBoxNick.Text, "1", this.textBoxSMSText.Text, nMsgId++, 1);
                // Посылка конкретному объекту
                //smsObject.SetMessage(this.textBoxSMSText.Text, "", 1, 255);
            }
            catch (COMException ex)
            {
                MessageBox.Show(string.Format("Message not sent to '{0}'.\n{1}\nObject busy or not Started.", this.textBoxSMSName.Text, ex.Message));
            }
            catch (ArgumentException ex)
            {
                MessageBox.Show(string.Format("'{0}' not registered on manager.\nObject not Started.", this.textBoxSMSName.Text));
            }
        }

        #region ISMSCallBack Members

        public void OnMessageShown(int MsgID)
        {
            if (this.InvokeRequired)
                this.Invoke(_setText, this.textBoxSended, MsgID.ToString());
            else
                _setText(this.textBoxSended, MsgID.ToString());
        }

        #endregion
    }
}
