// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

#define PEK_TX_TECHLEVEL 2
#include "textfile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CDemoDlg dialog




CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_START, &CDemoDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &CDemoDlg::OnBnClickedStop)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnDestroy()
{
	CDialog::OnDestroy();

	OnBnClickedStop();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



// -------------------------------------------------------------------------------- //
//
// RunTimeTitleSDK usage
//  double crawl playback
//
// -------------------------------------------------------------------------------- //

// MinShowTime is time of playback "empty" area between crawls - time = width/(speed*fps)
const double g_fMinShowTime = 720.0 / (5.0 * 25.0);

#import "TitleSDK\SLTMTitleRunTime.tlb" raw_interfaces_only named_guids

const CLSID CLSID_SLTMTitleServerTargetMgr = {0xDD02FC80,0x7D6E,0x440B,{0xBF,0x32,0x1A,0x29,0x77,0x4D,0xDC,0x1A}};
const CLSID CLSID_SLTMTitleNoPremultServerTargetMgr = {0xABCCE56A,0xC309,0x4FC8,{0x93,0x71,0x0F,0x58,0xCB,0xAA,0xAC,0x68}};
const CLSID CLSID_SLDirectShowTitleEngine = {0x73DA552F,0x4946,0x4670,{0x84,0x84,0x95,0x8F,0x97,0xA2,0x23,0xF2}};
// work on FD300 board:
//GUID guidTitleTarget = CLSID_SLTMTitleServerTargetMgr;
// work without FD300 board (run SLTitlePreview):
GUID guidTitleTarget = CLSID_SLDirectShowTitleEngine;

static void ShowErrorMsg(HRESULT hres)
{
	CComPtr<IErrorInfo> pIError;
	if( GetErrorInfo(0,&pIError)==S_OK ) {
		CComBSTR bstr;
		pIError->GetDescription(&bstr);
		CString str(bstr);
		::MessageBox(NULL, str, _T("Title Usage Error"), MB_ICONERROR);
	} else {
		CString str;
		str.Format(_T("Error = 0x%X"), hres);
		::MessageBox(NULL, str, _T("Title Usage Error"), MB_ICONERROR);
	}
}

#define CHECK_RESULT(hres) { if( FAILED(hres) ) { ShowErrorMsg(hres);  return; } }
#define CHECK_RESULT2(hres) { if( FAILED(hres) ) { ShowErrorMsg(hres);  return hres; } }

class CTitleProjectInfo {
public:
	CComPtr<SLTMTitleRunTime::ISLTMTitleRunTimeMgr2> m_pIProject;
	CComPtr<SLTMTitleRunTime::ISLTMTitleRunTime3> m_pICrawl[2];
	int m_nActiveIndex;
public:
	CTitleProjectInfo()
	{
		m_pIProject = NULL;
		m_pICrawl[0] = NULL;
		m_pICrawl[1] = NULL;
		m_nActiveIndex = 0;
		// load title project
		HRESULT hres = m_pIProject.CoCreateInstance(SLTMTitleRunTime::CLSID_TitleProjectMgr);
		CHECK_RESULT(hres);
		CComBSTR bstrName(_T("C:\\Crawl2.SLTitleProj"));
		hres = m_pIProject->Init((BSTR)bstrName, 0, &guidTitleTarget);
		CHECK_RESULT(hres);
		// obtain pointers to crawls
		CComPtr<IUnknown> pIUnk;
		hres = m_pIProject->GetRunTimeInterface(0,&pIUnk);
		CHECK_RESULT(hres);
		pIUnk->QueryInterface(&m_pICrawl[0]);
		pIUnk = NULL;
		hres = m_pIProject->GetRunTimeInterface(1,&pIUnk);
		CHECK_RESULT(hres);
		pIUnk->QueryInterface(&m_pICrawl[1]);
		pIUnk = NULL;
		// active first line
		ActiveCrawl(0, 0.0);
	}
	~CTitleProjectInfo()
	{
		if( m_pICrawl[0] ) { m_pICrawl[0]->Abort(0);  m_pICrawl[0]=NULL; }
		if( m_pICrawl[1] ) { m_pICrawl[1]->Abort(0);  m_pICrawl[1]=NULL; }
		if( m_pIProject != NULL ) { m_pIProject->Uninit();  m_pIProject=NULL; }
	}
	HRESULT ActiveCrawl(int index, double time)
	{
		static int nCnt = 0;
		CString strFileName(_T("C:\\Task.txt"));
		CTextFileWrite file(strFileName, CTextFileBase::UNI16_BE);
		if( !file.IsOpen() ) { ::MessageBox(NULL,_T("Can not create task file!"),_T("Title Usage Error"),MB_OK);  return E_FAIL; }
		CString str;  str.Format(_T("It is test text line for 2 crawl playback test. Text line number %d."),++nCnt);
		file.Write(str);
		file.Close();
		CComBSTR bstr(strFileName);
		HRESULT hres = m_pICrawl[index]->LoadTask(bstr);
		CHECK_RESULT2(hres);
		for( int i=0; i<10; i++ ) {
			SLTMTitleRunTime::SLTMRunTimeStatus status;
			hres = m_pICrawl[index]->get_Status(&status);
			CHECK_RESULT2(hres);
			if( status==SLTMTitleRunTime::SLTMRunTimeStatus_eStopped )  break;
			Sleep(40);
		}
		hres = m_pICrawl[index]->Start(time,0);
		CHECK_RESULT2(hres);
		double fCurTime=0,fRestTime=0,fDuration=0;  long bLooped=true;
		hres = m_pICrawl[index]->GetPlayInfo(&fCurTime, &fRestTime, &fDuration, &bLooped);
		CHECK_RESULT2(hres);
		if( fDuration < 0.001 )  return E_FAIL;
		m_nActiveIndex = index;
		return S_OK;
	}
	HRESULT CheckTime()
	{
		// obtain rest playback time
		double fCurTime=0,fRestTime=0,tmp1;  long tmp2;
		HRESULT hres = m_pICrawl[m_nActiveIndex]->GetPlayInfo(&fCurTime, &fRestTime, &tmp1, &tmp2);
		CHECK_RESULT2(hres);
		if( fRestTime < g_fMinShowTime+0.3 ) {
			double time = fCurTime + fRestTime - g_fMinShowTime;
			hres = ActiveCrawl(m_nActiveIndex==0 ? 1 : 0, time);
		}
		return hres;
	}
};
static CTitleProjectInfo *info = NULL;
static UINT_PTR m_nTimerID = 0;

void CDemoDlg::OnBnClickedStart()
{
	if( info != NULL )  return;
	info = new CTitleProjectInfo();
	m_nTimerID = SetTimer(1,100,NULL);
}

void CDemoDlg::OnBnClickedStop()
{
	if( m_nTimerID != 0 ) { KillTimer(m_nTimerID);  m_nTimerID=0; }
	if( info != NULL ) { delete info;  info=NULL; }
}

void CDemoDlg::OnTimer(UINT_PTR nIDEvent)
{
	static bool bInTimer = false;
	if( !bInTimer ) {
		bInTimer = true;
		if( info != NULL ) {
			if( info->CheckTime() != S_OK )  OnBnClickedStop();
		}
		bInTimer = false;
	}
	CDialog::OnTimer(nIDEvent);
}
