

Public Class Form1

    Private titleMgr As SLTMTitleRunTime.ISLTMTitleRunTimeMgr = Nothing
    Private titleObjectCurr As SLTMTitleRunTime.ISLTMTitleRunTime3 = Nothing
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If titleMgr Is Nothing Then
            titleMgr = New SLTMTitleRunTime.TitleProjectMgr()
        End If
        OpenFileDialog1.Filter = "TitleProject Files(*.SlTitleProj)|*.SlTitleProj|All Files|*.*"
        If OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            TextBox1.Text = OpenFileDialog1.FileName
            Try
                titleMgr.Init(OpenFileDialog1.FileName, 0)
                tbNumObjects.Text = titleMgr.NumObjects.ToString()
                lbObjects.Items.Clear()
                For i As Integer = 0 To titleMgr.NumObjects - 1
                    lbObjects.Items.Add(titleMgr.GetName(i))
                Next
                If titleMgr.NumObjects > 0 Then
                    lbObjects.SelectedIndex = 0
                End If
            Catch ex As Exception
                MsgBox(ex.Message)
                lbObjects.Items.Clear()
                titleMgr.Uninit()
                titleMgr = Nothing
            End Try
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If titleMgr IsNot Nothing Then
            For i As Integer = 0 To titleMgr.NumObjects - 1
                Try
                    Dim titleObject As SLTMTitleRunTime.ISLTMTitleRunTime3 = titleMgr.GetRunTimeInterface(i)
                    titleObject.Start(0, 0.2)
                Catch ex As Exception
                End Try
            Next
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If titleMgr IsNot Nothing Then
            For i As Integer = 0 To titleMgr.NumObjects - 1
                Try
                    Dim titleObject As SLTMTitleRunTime.ISLTMTitleRunTime3 = titleMgr.GetRunTimeInterface(i)
                    titleObject.Stop(0, 0.2)
                Catch ex As Exception
                End Try
            Next
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        If titleMgr IsNot Nothing Then
            For i As Integer = 0 To titleMgr.NumObjects - 1
                Try
                    Dim titleObject As SLTMTitleRunTime.ISLTMTitleRunTime3 = titleMgr.GetRunTimeInterface(i)
                    titleObject.Abort(0.2)
                Catch ex As Exception
                End Try
            Next
        End If
    End Sub

    Private Sub lbObjects_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbObjects.SelectedIndexChanged
        If titleMgr IsNot Nothing Then
            Try
                titleObjectCurr = titleMgr.GetRunTimeInterface(lbObjects.SelectedIndex)
                tbCurrName.Text = titleObjectCurr.Name
                tbTask.Text = titleObjectCurr.TaskFileName
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If titleObjectCurr IsNot Nothing Then
            Try
                Dim currTime As Double
                Dim restTime As Double
                Dim allDuration As Double
                Dim loopped As Boolean
                titleObjectCurr.GetPlayInfo(currTime, restTime, allDuration, loopped)
                tbCurrTime.Text = currTime.ToString("F2")
                tbRestTime.Text = restTime.ToString("F2")
                tbDuration.Text = allDuration.ToString("F2")
                If loopped Then
                    tbLoopped.Text = "Loopped"
                Else
                    tbLoopped.Text = "Not Loopped"
                End If
                tbStatus.Text = titleObjectCurr.Status.ToString()

            Catch ex As Exception

            End Try

        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Reload.Click
        If titleObjectCurr IsNot Nothing Then
            Try
                titleObjectCurr.LoadTask(tbTask.Text)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
    End Sub

    Private Sub BrowseTask_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BrowseTask.Click
        If titleObjectCurr IsNot Nothing Then
            Try
                OpenFileDialog1.Filter = titleObjectCurr.TaskFileMask + "All Files|*.*"
                OpenFileDialog1.FileName = tbTask.Text
                If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
                    tbTask.Text = OpenFileDialog1.FileName
                    titleObjectCurr.LoadTask(OpenFileDialog1.FileName)
                End If
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
    End Sub
End Class
