using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Security.AccessControl;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using SLTMTitleRunTime;
//using SLTMPlaybackLib;

namespace FDTitleCSharp
{
	public partial class Form1 : Form
	{

		private SLTMTitleRunTime.ISLTMTitleRunTimeMgr titleMgr = null;
		private SLTMTitleRunTime.ISLTMTitleRunTime3 titleObjectCurr = null;
		private String _guardEventName = typeof(FDTitleCSharp.Form1).Namespace + Guid.NewGuid().ToString("D");
		private EventWaitHandle _guardObj = null;

		public Form1()
		{
			InitializeComponent();
			//bool createdNew = false;
			//var sec = new EventWaitHandleSecurity();
			//EventWaitHandleAccessRule rule = new EventWaitHandleAccessRule("",
			//	EventWaitHandleRights.Synchronize |
			//	EventWaitHandleRights.Modify,
			//	AccessControlType.Allow);
			//sec.AddAccessRule(rule);
			//_guardObj = new EventWaitHandle(false, EventResetMode.ManualReset, _guardEventName, out createdNew, sec);
			_guardObj = new EventWaitHandle(false, EventResetMode.ManualReset, _guardEventName);

		}

		class Engine
		{
			public readonly String	_name;
			public readonly Guid	_guid;
			public readonly int		_index;
			public Engine(String name, Guid guid, int index)
			{
				_name = name;
				_guid = guid;
				_index = index;
			}
			public override string ToString()
			{
				return _name;
			}
		}
		private void Form1_Load(object sender, EventArgs e)
		{
			SLTMPlaybackLib.ISLTMEnumVideoPlayer4TE vpEnum = new SLTMPlaybackLib.SLTMEnumVideoPlayer4TE();
			for (int i = 0; i < vpEnum.Count; ++i) {
				var item = new Engine(vpEnum.Name[i], vpEnum.type[i], vpEnum.index[i]);
				cbEngines.Items.Add(item);
			}
			if (cbEngines.Items.Count > 0) {
				cbEngines.SelectedIndex = 0;
				currEngine = (Engine)cbEngines.SelectedItem;
			}
		}

		Engine currEngine = null;

		private void ClearAll()
		{
			if (titleMgr != null) {
				lbObjects.Items.Clear();
				titleObjectCurr = null; 
				titleMgr.Uninit();
			}
			titleMgr = null;
		}


		static  private Guid _SLTMTitleServerTargetMgr = new Guid("dd02fc80-7d6e-440b-bf32-1a29774ddc1a");
		static  private Guid _SLTMTitleCTV1ServerTargetMgr = new Guid("c23977fa-73aa-46f9-9fcf-a68953f2d708");
		static  private Guid _SLTMTitleCTV2ServerTargetMgr = new Guid("a604a024-60f4-4674-a76e-3d4229c40da0");
		static  private Guid _SLTMTitleArtServerTargetMgr = new Guid("4acf2000-688a-4cfe-b524-1afb657136ab");
		static  private Guid _SLTMTitleBackServerTargetMgr = new Guid("bb94349b-d939-459f-80d7-12af0726aacb");
		static  private Guid _SLTMTitleNoPremultServerTargetMgr = new Guid("abcce56a-c309-4fc8-9371-0f58cbaaac68");

		static  private Guid _DSTitleFilterMgr = new Guid("{0x73DA552F,0x4946,0x4670,{0x84,0x84,0x95,0x8F,0x97,0xA2,0x23,0xF2}}");
		static  private Guid _DVMTitleTargetMgr = new Guid("{0xCA5260BE,0x10C2,0x438A,{0xB5,0xA5,0x94,0x23,0x7C,0x05,0x83,0x17}}");
		static  private Guid _FDExtTitleFilterMgr = new Guid("{0xBAFE501E,0x4874,0x4EF9,{0x8E,0xF3,0x22,0xD8,0xF3,0x97,0xDC,0x82}}");

		private void BrowseProject_Click(object sender, EventArgs e)
		{
			openFileDialog1.Filter = "TitleProject Files(*.SlTitleProj)|*.SlTitleProj|All Files|*.*";
			openFileDialog1.FileName = tbProjectFile.Text;
			if (openFileDialog1.ShowDialog(this) == System.Windows.Forms.DialogResult.OK) {
				tbProjectFile.Text = openFileDialog1.FileName;
				InitProject();
			}

		}

		private void InitProject()
		{
			if (String.IsNullOrEmpty(tbProjectFile.Text)) 
				return;
			ClearAll();

			if (titleMgr == null) {
				titleMgr = (SLTMTitleRunTime.ISLTMTitleRunTimeMgr)SLTitleProjectMgrCreator.Create
					(
						useDLL.Checked ? SLTitleProjectMgrCreator.ClassIdDll : SLTitleProjectMgrCreator.ClassIdExe
					);//new SLTMTitleRunTime.TitleProjectMgr();

				try {
					var primaryInit = titleMgr as SLTMTitleRunTime.ISLTMTitlePrimaryInit;
					if (primaryInit != null) {
						primaryInit.PrimaryInit(0x409, _guardEventName);
					}
				}
				catch (Exception err) {
					MessageBox.Show(this, err.Message, "primaryInit");
					return;
				}
			} 
			//else {
			//	ClearAll();
			//}

			try {
				SLTMTitleRunTime.ISLTMTitleRunTimeMgr2 titleMgr2 = titleMgr as SLTMTitleRunTime.ISLTMTitleRunTimeMgr2;
				if (titleMgr2 != null) {
					if (currEngine != null) {
						Guid guid = currEngine._guid;
						titleMgr2.Init(tbProjectFile.Text, currEngine._index, ref guid);
					} else {
						titleMgr2.Init(tbProjectFile.Text, 0, ref _FDExtTitleFilterMgr);
					}
				} else {
					titleMgr.Init(tbProjectFile.Text, 0);
				}
				tbNumObjects.Text = titleMgr.NumObjects.ToString();
				lbObjects.Items.Clear();
				for (int i = 0; i < titleMgr.NumObjects; i++) {
					lbObjects.Items.Add(titleMgr.GetName(i));
				}
				if (titleMgr.NumObjects > 0) {
					lbObjects.SelectedIndex = 0;
				}
			}
			catch (Exception err) {
				MessageBox.Show(this, err.Message);
				ClearAll();
			}
		}
        volatile int reenter = 0;
		private void timer1_Tick(object sender, EventArgs e)
		{
			if (titleObjectCurr != null) {
                try {
                    if (++reenter > 1)
                        return;
                    double currTime;
                    double restTime;
                    double allDuration;
                    bool loopped;
                    titleObjectCurr.GetPlayInfo(out currTime, out restTime, out allDuration, out loopped);
                    tbGlobalTime.Text = currTime.ToString("F2");
                    tbRestTime.Text = restTime.ToString("F2");
                    tbDuration.Text = allDuration.ToString("F2");
                    if (loopped) {
                        tbLoopped.Text = "Loopped";
                    }
                    else {
                        tbLoopped.Text = "Not Loopped";
                    }
                    tbStatus.Text = titleObjectCurr.Status.ToString();
                }
                catch { }
                finally {
                    reenter--;
                }
 			}
 		}

		private void lbObjects_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (titleMgr != null) {
				try {
					object obj = titleMgr.GetRunTimeInterface(lbObjects.SelectedIndex);
					titleObjectCurr = (ISLTMTitleRunTime3)obj;
					tbCurrName.Text = titleObjectCurr.Name;
					tbTask.Text = titleObjectCurr.TaskFileName;
				}
				catch (Exception err)  {
					MessageBox.Show(err.Message);
				}
			}
		}

		private void StartAll_Click(object sender, EventArgs e)
		{
			if (titleMgr == null) 
				return;
			int count = titleMgr.NumObjects;
			for (int i = 0; i < count; i++) {
				try {
					var obj = (ISLTMTitleRunTime3)titleMgr.GetRunTimeInterface(i);
					obj.Start(0, 0.5);
				}
				catch (Exception /*err*/) {
					//MessageBox.Show(err.Message);
				}
			}
		}

		private void StopAll_Click(object sender, EventArgs e)
		{
			if (titleMgr == null)
				return;
			int count = titleMgr.NumObjects;
			for (int i = 0; i < count; i++) {
				try {
					var obj = (ISLTMTitleRunTime3)titleMgr.GetRunTimeInterface(i);
					obj.Stop(0, 0.5);
				}
				catch (Exception /*err*/) {
					//MessageBox.Show(err.Message);
				}
			}
		}

		private void AbortAll_Click(object sender, EventArgs e)
		{
			if (titleMgr == null)
				return;
			int count = titleMgr.NumObjects;
			for (int i = 0; i < count; i++) {
				try {
					var obj = (ISLTMTitleRunTime3)titleMgr.GetRunTimeInterface(i);
					obj.Abort(0.5);
				}
				catch (Exception /*err*/) {
					//MessageBox.Show(err.Message);
				}
			}
		}

		private void BrowseTask_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			openFileDialog1.Filter = titleObjectCurr.TaskFileMask + "All Files|*.*";
			openFileDialog1.FileName = tbTask.Text;
			if (openFileDialog1.ShowDialog(this) == System.Windows.Forms.DialogResult.OK) {
				tbTask.Text = openFileDialog1.FileName;
				try {
					titleObjectCurr.LoadTask(tbTask.Text);
				}
				catch (Exception err) {
					MessageBox.Show(err.Message);
				}
			}
		}

		private void Reload_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				titleObjectCurr.LoadTask(tbTask.Text);
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

		private void Start_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				double time = (double)startTime.Value;//Double.Parse(startTime.Value, System.Globalization.CultureInfo.InvariantCulture);
				//time = -time;
				titleObjectCurr.Start(time, 0.5);
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

		private void Stop_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				double time = (double)stopTime.Value;//Double.Parse(stopTime.Value, System.Globalization.CultureInfo.InvariantCulture);
				//time = -time;
				titleObjectCurr.Stop(time, 0.5);
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

		private void Abort_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				double time = (double)abortDuration.Value;//Double.Parse(abortDuration.Value, System.Globalization.CultureInfo.InvariantCulture);
				titleObjectCurr.Abort(time);
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

		private void ShowProperties_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				var props = titleObjectCurr as ISLTMTitleObjectProperties2;
				if (props != null) {
					props.ShowDialog((long)this.Handle);
				}
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

        private void btElements_Click(object sender, EventArgs e) {
            if (titleObjectCurr == null)
                return;
            try {
				using (var elementsForm = new ElementsForm(titleObjectCurr)) {
					elementsForm.ShowDialog(this);
				}
            }
            catch (Exception err) {
                MessageBox.Show(err.Message);
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e) {
            titleObjectCurr = null;
			ClearAll();
			titleMgr = null;
        }

		private void lbObjects_DoubleClick(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				var props = titleObjectCurr as ISLTMTitleObjectProperties2;
				if (props != null) {
					props.Show((long)this.Handle);
				}
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

		private void useDLL_CheckedChanged(object sender, EventArgs e)
		{
			InitProject();
		}

		private void cbEngines_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (cbEngines.Items.Count > 0) {
				currEngine = (Engine)cbEngines.SelectedItem;
			}
			InitProject();
		}
	}
}