#pragma once
#include "afxwin.h"


// CFlipFlopDlg dialog

class CFlipFlopDlg : public CDialog
{
	DECLARE_DYNAMIC(CFlipFlopDlg)

public:
	CFlipFlopDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CFlipFlopDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_FLIP_FLOP };
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

	UINT_PTR m_TimerId = 0;
	ISLTMTitleRunTime3Ptr m_titleObject;
	ISLTMTitleRunTimePreloadPtr m_titlePreload;
	CString m_strInitialTaskDir;
	CString m_strTaskFileName;
	bool m_bRunning = false;
	bool m_bNextReady = false;
	int m_lastPreloadedIndex = -1;
	bool m_bShowError = true;

	void UpdateStatus();
	CString GetStatusStr(SLTMRunTimeStatus status);
	CString GetPreloadStatusStr(SLTMPreloadStatus status);

	double GetFade() { 

		auto val = (double)GetDlgItemInt(IDC_CRAOSS_FADE) / 1000.0; 
		return max(0, val);
	}

	double GetMarkIn() {

		auto val = (double)GetDlgItemInt(IDC_MARK_IN) / 1000.0;
		return max(0, val);
	}

	double GetMarkOut() {

		auto val = (double)GetDlgItemInt(IDC_MARK_OUT) / 1000.0;
		return max(0, val);
	}


	void LimitLines(CString& str, int limit = 50) 
	{
		CString newStr;

		CString resToken;
		int curPos = 0;
		int count = 0;

		str += _T("\n");
		resToken = str.Tokenize(_T("\n"), curPos);
		while (/*resToken != _T("") &&*/ curPos != -1 && count++ < limit) {
			newStr += resToken + _T("\n");
			resToken = str.Tokenize(_T("\n"), curPos);
		}
		if (count >= limit && curPos != -1 /*&& resToken != _T("")*/) {
			newStr += _T("...\n");
		}
		str = newStr;
	}

	void ShowError(_com_error& err) {
		if (err.Error() == 0x81234567) return;	//   ProcessedException 
		CString errStr = (LPCTSTR)err.Description();
		if (errStr.IsEmpty())
			errStr = err.ErrorMessage();

		LimitLines(errStr);

		MessageBox(errStr, err.Source().GetBSTR(), MB_OK | (err.Error() == 0x80042000 ? MB_ICONWARNING : MB_ICONERROR));
	}
public:
	HRESULT InitObject(ISLTMTitleRunTime3* titleObject);
	afx_msg void OnBnClickedStart();
	afx_msg void OnBnClickedStop();
	afx_msg void OnBnClickedAbort();
	afx_msg void OnBnClickedAdd();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	CListBox m_TimeLine;
	afx_msg void OnLbnSelchangeTimeLine();
	int GetSelectedFile(CString &file);
	int GetNextFile(CString &file);
	void StartNext();
	void StartNow();
	afx_msg void OnLbnDblclkTimeLine();
	afx_msg void OnBnClickedStartFirst();
};
