// NonifyEditor.cpp:  
//

#include "stdafx.h"
#include "TitleRunTimeTest.h"
#include "TitleRunTimeTestDlg.h"
#include "NonifyEditor.h"


//   CNonifyEditor

IMPLEMENT_DYNAMIC(CNonifyEditor, CDialog)

CNonifyEditor::CNonifyEditor(CWnd* pParent /*=NULL*/)
	: CDialog(CNonifyEditor::IDD, pParent)
	, m_fileName(_T(""))
	, m_duration(0)
	,m_comments(_T(""))
	, m_preview(_T(""))
{

}

CNonifyEditor::~CNonifyEditor()
{
}

void CNonifyEditor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_FILE_NAME, m_fileName);
	DDX_Text(pDX, IDC_EDIT_DURATION, m_duration);
	DDX_Text(pDX, IDC_EDIT_COMMENTS, m_comments);
	DDX_Text(pDX, IDC_EDIT_PREVIEW, m_preview);
}


BEGIN_MESSAGE_MAP(CNonifyEditor, CDialog)
	ON_BN_CLICKED(IDOK, &CNonifyEditor::OnBnClickedOk)
	ON_BN_CLICKED(IDC_PREVIEW, &CNonifyEditor::OnBnClickedPreview)
END_MESSAGE_MAP()


//   CNonifyEditor

void CNonifyEditor::Init(LPCTSTR fileName, double duration, LPCTSTR comments)
{
	m_fileName = fileName;
	m_duration = duration;
	m_comments = comments;
	m_preview = CTitleRunTimeTestDlg::FormatNotify(m_fileName, 1.1, m_duration, m_comments);
	//UpdateData(FALSE);
}

void CNonifyEditor::OnBnClickedOk()
{
	UpdateData();
	OnOK();
}

void CNonifyEditor::OnBnClickedPreview()
{
	UpdateData();
	m_preview = CTitleRunTimeTestDlg::FormatNotify(m_fileName, 1.1, m_duration, m_comments);
	UpdateData(FALSE);
}
