// TitleRunTimeTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TitleRunTimeTest.h"
//#include <Shlwapi.h>
#include ".\TitleRunTimeTestDlg.h"
#include <math.h>

#include "NonifyEditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();

	BOOL VerQueryValue(const LPVOID pBlock, CString& lpSubBlock, LPWSTR *lplpBuffer, PUINT puLen )
	{
		return ::VerQueryValue(pBlock, (LPTSTR)(LPCTSTR)lpSubBlock, (LPVOID *)lplpBuffer, puLen );
	}
	BOOL VerQueryValue(const LPVOID pBlock, CString& lpSubBlock, LPSTR *lplpBuffer, PUINT puLen )
	{
		CT2A subBlock(lpSubBlock);
		return ::VerQueryValueA(pBlock, subBlock, (LPVOID *)lplpBuffer, puLen );
	}
	CString m_product;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
, m_product(_T(""))
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, ID_PRODUCT, m_product);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTitleRunTimeTestDlg dialog

CTitleRunTimeTestDlg::CTitleRunTimeTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTitleRunTimeTestDlg::IDD, pParent)
	, m_strConfigFileName(_T(""))
	, m_strTaskFileName(_T(""))
	, m_strStatus(_T(""))
	, m_strInitialConfigDir(_T(""))
	, m_strInitialTaskDir(_T(""))
	, m_StartDelay(0)
	, m_StopDelay(0)
	, m_StartDuration(0.5)
	, m_StopDuration(0.5)
	, m_AbortDuration(0)
	, m_TimerId(0)
	, m_CurrTime(_T(""))
	, m_RestTime(_T(""))
	, m_Duration(_T(""))
	, m_Loopped(_T(""))
	, m_SelectedName(_T(""))
	, m_alphaEdit(0)
	, m_currAlpha(0)
	, m_alphaDelay(0)
	, m_alphaDuration(0)
	, m_useRestForStartStop(FALSE)
	, m_bTestActive(false)
	, m_tickCounter(-1)
	, m_notifyChecked(-1)
	//, m_notifyStatus(_T("Unknown"))
    //, m_fd300TargetCount(0)
    //, m_fd300BoardCount(-1)
    , m_currLang(_T(""))
	, m_dll(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	TCHAR strDefDir[MAX_PATH];
	GetCurrentDirectory(MAX_PATH, strDefDir);
	m_strInitialConfigDir = AfxGetApp()->GetProfileString(_T("OpenFile"), _T("LastConfigDir"), strDefDir);
	if (!::PathFileExists(m_strInitialConfigDir)) {
		m_strInitialConfigDir = strDefDir;
	}
	m_strInitialTaskDir = AfxGetApp()->GetProfileString(_T("OpenFile"), _T("LastTaskDir"), strDefDir);
	if (!::PathFileExists(m_strInitialTaskDir)) {
		m_strInitialTaskDir = strDefDir;
	}

	m_notifyFile = AfxGetApp()->GetProfileString(_T("Notify"), _T("notifyFile"), _T("E:\\Video\\about_programmers.mpg"));
	m_notifyDuration = (double)AfxGetApp()->GetProfileInt(_T("Notify"), _T("notifyDuration"), int(1.0*60.0 * 1000))/1000.0;  // 1 
	m_notifyComments = AfxGetApp()->GetProfileString(_T("Notify"), _T("notifyComments"), _T("annonce :  \r\nmclipinfo SL_Muz_info.avi\r\nmclipinfo   comments||(c) Microsoft\r\n"));
	
}

CTitleRunTimeTestDlg::~CTitleRunTimeTestDlg() 
{
	try {
		ClearAll();
		m_titleMgr = NULL;;
	} catch (...) {//_com_error& err) {
		//ShowError(err);
	}
	AfxGetApp()->WriteProfileString(_T("OpenFile"), _T("LastConfigDir"), m_strInitialConfigDir);
	AfxGetApp()->WriteProfileString(_T("OpenFile"), _T("LastTaskDir"), m_strInitialTaskDir);
	AfxGetApp()->WriteProfileString(_T("Notify"), _T("notifyFile"), m_notifyFile);
	AfxGetApp()->WriteProfileInt(_T("Notify"), _T("notifyDuration"), int(m_notifyDuration * 1000.0));  // 1 
	AfxGetApp()->WriteProfileString(_T("Notify"), _T("notifyComments"), m_notifyComments);
}

void CTitleRunTimeTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_CONFIG_FILE_EDIT, m_strConfigFileName);
	DDX_Text(pDX, IDC_TASK_FILE_EDIT, m_strTaskFileName);
	DDX_Text(pDX, IDC_STATUS, m_strStatus);
	DDX_Control(pDX, IDC_OBJECTS_LIST, m_TitleObjectsList);
	DDX_Text(pDX, IDC_START_DELAY, m_StartDelay);
	DDV_MinMaxDouble(pDX, m_StartDelay, 0.0, 1000.0);
	DDX_Text(pDX, IDC_STOP_DELAY, m_StopDelay);
	DDV_MinMaxDouble(pDX, m_StopDelay, 0.0, 1000.0);
	DDX_Text(pDX, IDC_START_DURATION, m_StartDuration);
	DDV_MinMaxDouble(pDX, m_StartDuration, 0.0, 100.0);
	DDX_Text(pDX, IDC_STOP_DURATION, m_StopDuration);
	DDV_MinMaxDouble(pDX, m_StopDuration, 0, 100.0);
	DDX_Text(pDX, IDC_ABORT_DURATION, m_AbortDuration);
	DDV_MinMaxDouble(pDX, m_AbortDuration, 0, 100.0);
	DDX_Text(pDX, IDC_CURR_TIME, m_CurrTime);
	DDX_Text(pDX, IDC_REST_TIME, m_RestTime);
	DDX_Text(pDX, IDC_DURATION, m_Duration);
	DDX_Text(pDX, IDC_LOOPED, m_Loopped);
	DDX_Control(pDX, IDC_BOARDS_LIST, m_BoardsList);
	DDX_Text(pDX, IDC_SELECTED_NAME, m_SelectedName);
	DDX_Text(pDX, IDC_ALPHA_EDIT, m_alphaEdit);
	DDX_Text(pDX, IDC_CURR_ALPHA_EDIT, m_currAlpha);
	DDX_Text(pDX, IDC_ALPHA_DELAY, m_alphaDelay);
	DDX_Text(pDX, IDC_ALPHA_DURATION, m_alphaDuration);
	//DDX_Control(pDX, IDC_TARGET_LIST, m_TargetList);
	DDX_Check(pDX, IDC_USE_REST_TIME, m_useRestForStartStop);
	//DDX_Text(pDX, IDC_NOTIFY_STATUS, m_notifyStatus);
	DDX_Control(pDX, IDC_LANG, m_Lang);
	DDX_Text(pDX, IDC_EDIT_CURR_LANG, m_currLang);
	DDX_Control(pDX, IDC_CHECK_DLL, m_LoadAsDll);
}

BEGIN_MESSAGE_MAP(CTitleRunTimeTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BROWSE_CONFIG, OnBnClickedBrowseConfig)
	ON_BN_CLICKED(IDC_BROWSE_TASK, OnBnClickedBrowseTask)
	ON_BN_CLICKED(IDC_LOAD_CONFIG, OnBnClickedLoadConfig)
	ON_BN_CLICKED(IDC_LOAD_TASK, OnBnClickedLoadTask)
	ON_BN_CLICKED(IDC_START, OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, OnBnClickedStop)
	ON_BN_CLICKED(IDC_ABORT, OnBnClickedAbort)
	ON_BN_CLICKED(IDC_UNINIT, OnBnClickedUninit)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_LBN_SELCHANGE(IDC_OBJECTS_LIST, OnLbnSelchangeObjectsList)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_GET_TASK_INFO, OnBnClickedGetTaskInfo)
	ON_CBN_SELCHANGE(IDC_BOARDS_LIST, OnCbnSelchangeBoardsList)
	ON_BN_CLICKED(IDC_START_ALL, OnBnClickedStartAll)
	ON_BN_CLICKED(IDC_STOP_ALL, OnBnClickedStopAll)
	ON_BN_CLICKED(IDC_ABORT_ALL, OnBnClickedAbortAll)
	ON_BN_CLICKED(IDC_SET_ALPHA, OnBnClickedSetAlpha)
	//ON_CBN_SELCHANGE(IDC_TARGET_LIST, OnCbnSelchangeTargetList)
	ON_BN_CLICKED(IDC_SHOW_PROPERTIES, OnBnClickedShowProperties)
	ON_LBN_DBLCLK(IDC_OBJECTS_LIST, OnLbnDblclkObjectsList)
	ON_BN_CLICKED(IDC_START_STOP, OnBnClickedStartStop)
    ON_BN_CLICKED(IDC_CREATE_LOG, &CTitleRunTimeTestDlg::OnBnClickedCreateLog)
    ON_CBN_SELCHANGE(IDC_ZORDER, &CTitleRunTimeTestDlg::OnCbnSelchangeZorder)
    ON_BN_CLICKED(IDC_SUPPRESS_WARNING, &CTitleRunTimeTestDlg::OnBnClickedSuppressWarning)
    ON_CBN_SELCHANGE(IDC_IGNORE_CANCEL, &CTitleRunTimeTestDlg::OnCbnSelchangeIgnoreCancel)
	ON_BN_CLICKED(IDC_TEST, &CTitleRunTimeTestDlg::OnBnClickedTest)
	ON_BN_CLICKED(IDC_DEBUG_SCRIPT_ENABLE, &CTitleRunTimeTestDlg::OnBnClickedDebugScriptEnable)
	ON_BN_CLICKED(IDC_EDIT_NOTIFY, &CTitleRunTimeTestDlg::OnBnClickedEditNotify)
	ON_BN_CLICKED(IDC_SEND_NOTIFY, &CTitleRunTimeTestDlg::OnBnClickedSendNotify)
	ON_BN_CLICKED(IDC_CHECK_NOTIFY, &CTitleRunTimeTestDlg::OnBnClickedCheckNotify)
	ON_BN_CLICKED(IDC_SEND_NOTIFY_LIVE, &CTitleRunTimeTestDlg::OnBnClickedSendNotifyLive)
    ON_CBN_SELCHANGE(IDC_LANG, &CTitleRunTimeTestDlg::OnCbnSelchangeLang)
    ON_WM_HSCROLL()
    ON_BN_CLICKED(IDC_CHECK_MUTE, &CTitleRunTimeTestDlg::OnBnClickedCheckMute)
	ON_BN_CLICKED(IDC_BOOM, &CTitleRunTimeTestDlg::OnBnClickedBoom)
	ON_BN_CLICKED(IDC_BOOM2, &CTitleRunTimeTestDlg::OnBnClickedBoom2)
	ON_BN_CLICKED(IDC_FLIP_FLOP, &CTitleRunTimeTestDlg::OnBnClickedFlipFlop)
END_MESSAGE_MAP()


//#define INITGUID
// 
// DEFINE_GUID(CLSID_DSTitleFilterMgr, 
// 			0x73DA552F, 0x4946, 0x4670, 0x84, 0x84, 0x95, 0x8F, 0x97, 0xA2, 0x23, 0xF2);
extern "C" const GUID __declspec(selectany) CLSID_DSTitleFilterMgr =
			{0x73DA552F,0x4946,0x4670,{0x84,0x84,0x95,0x8F,0x97,0xA2,0x23,0xF2}};

extern "C" const GUID __declspec(selectany) CLSID_DVMTitleTargetMgr = 
	{0xCA5260BE,0x10C2,0x438A,{0xB5,0xA5,0x94,0x23,0x7C,0x05,0x83,0x17}};

extern "C" const GUID __declspec(selectany) CLSID_FDExtTitleFilterMgr =
	{0xBAFE501E,0x4874,0x4EF9,{0x8E,0xF3,0x22,0xD8,0xF3,0x97,0xDC,0x82}};

// CTitleRunTimeTestDlg message handlers

BOOL CTitleRunTimeTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CreateGuardEvent();

    m_Lang.ResetContent();
    m_Lang.SetItemData(m_Lang.AddString(_T("System default")), LOCALE_SYSTEM_DEFAULT);
    m_Lang.SetItemData(m_Lang.AddString(_T("User default")), LOCALE_USER_DEFAULT);
    m_Lang.SetItemData(m_Lang.AddString(_T("English")), MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_DEFAULT), SORT_DEFAULT));
    m_Lang.SetItemData(m_Lang.AddString(_T("")), MAKELCID(MAKELANGID(LANG_RUSSIAN, SUBLANG_DEFAULT), SORT_DEFAULT));
    m_Lang.SetCurSel(0);

    m_currLang = GetCurrentLocaleName();

	m_LoadAsDll.SetCheck(m_dll);
	if (!CreateTitleMgr())
	{
		m_dll = !m_dll;
		m_LoadAsDll.SetCheck(m_dll);
		if (!CreateTitleMgr())
		{
			PostMessage(WM_CLOSE);
			return FALSE;
		}
	}

 //   m_fd300TargetCount = 0;
	//m_TargetList.ResetContent();
 //   if (GetFD300BoardCount() > 0) 
 //   {
 //       //  FD300 
 //       m_TargetList.SetItemDataPtr(m_TargetList.AddString(_T("Title")), (void*)&SLTMSRVDLib::CLSID_SLTMTitleServerTargetMgr);
 //       m_TargetList.SetItemDataPtr(m_TargetList.AddString(_T("Artist")), (void*)&SLTMSRVDLib::CLSID_SLTMTitleArtServerTargetMgr);
 //       m_TargetList.SetItemDataPtr(m_TargetList.AddString(_T("Background")), (void*)&SLTMSRVDLib::CLSID_SLTMTitleBackServerTargetMgr);
 //       m_TargetList.SetItemDataPtr(m_TargetList.AddString(_T("TitleNoPremult")), (void*)&SLTMSRVDLib::CLSID_SLTMTitleNoPremultServerTargetMgr);
 //   }
 //   m_fd300TargetCount = m_TargetList.GetCount();
 //   m_TargetList.SetItemDataPtr(m_TargetList.AddString(_T("FDExt")), (void*)&CLSID_FDExtTitleFilterMgr);
	//m_TargetList.SetItemDataPtr(m_TargetList.AddString(_T("DSTitle")), (void*)&CLSID_DSTitleFilterMgr);
	//m_TargetList.SetItemDataPtr(m_TargetList.AddString(_T("DVMTitle")), (void*)&CLSID_DVMTitleTargetMgr);
	//m_TargetList.SetCurSel(0);

	FillBoardList(0);
	//SLTMSRVDLib::ISLTMSrvPtr psIServer;
	//hr = psIServer.CreateInstance(CLSID_SLTMSrv);

	//long boardCount = 0;
	//if (SUCCEEDED(hr)) {
	//	hr = psIServer->get_BoardsCount(&boardCount);
	//	if (FAILED(hr) || boardCount < 1) {
	//		MessageBox(GetErrorMessage(hr), _T("get_BoardsCount SLTMSrv"), MB_OK|MB_ICONERROR);
	//		PostMessage(WM_CLOSE);
	//		return FALSE;
	//	}
	//	m_BoardsList.ResetContent();
	//	for (int i = 0; i < boardCount; ++i) {
	//		CString name; name.Format(_T("Board #%d"), i+1);
	//		m_BoardsList.SetItemData(m_BoardsList.AddString(name), i);
	//	}
	//}
	//else {
	//	m_BoardsList.Clear();
	//	for (int i = 0; i < 20; ++i) {
	//		CString name; name.Format(_T("TitleEngine #%d"), i);
	//		m_BoardsList.SetItemData(m_BoardsList.AddString(name), i);
	//	}
	//	m_TargetList.SetCurSel(3); // for FDExt boards
	//}

	//m_BoardsList.SetCurSel(0);

	m_TimerId = (UINT)SetTimer(1, 500, NULL);

    CComboBox *pZOrder = (CComboBox*)GetDlgItem(IDC_ZORDER);
    pZOrder->Clear();
    for (int i = 0; i <= 10; i++) {
        CString str; str.Format(_T("%d"), i*1000);
        pZOrder->SetItemData(pZOrder->AddString(str), i*1000);
    }
    pZOrder->SetCurSel(0);

    CComboBox* ignoreCtrl = (CComboBox*)GetDlgItem(IDC_IGNORE_CANCEL);
    ignoreCtrl->SetCurSel(0);
    ((CButton*)GetDlgItem(IDC_SUPPRESS_WARNING))->SetCheck(BST_UNCHECKED);
	((CButton*)GetDlgItem(IDC_DEBUG_SCRIPT_ENABLE))->SetCheck(BST_CHECKED);

    CSliderCtrl *pVolume = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_VOLUME);
    pVolume->SetPos(0);
    pVolume->SetPageSize(100);
    pVolume->SetLineSize(10);
    pVolume->SetRange(-9600, 1200, TRUE);
    pVolume->Invalidate();
    pVolume->SetPos(0);

    SetDlgItemText(IDC_EDIT_VOLUME, _T("0.00dB"));


    SuppressWarning();

	UpdateStatus();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTitleRunTimeTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTitleRunTimeTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTitleRunTimeTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTitleRunTimeTestDlg::OnBnClickedBrowseConfig()
{
	//ClearAll();

	CString strFilters(_T("Title Project Files (*.SLTitleProj)|*.SLTitleProj|All Files (*.*)|*.*||"));

	// Create an Open dialog; the default file name extension is ".xml". 
	CFileDialog fileDlg (TRUE, NULL, NULL, OFN_HIDEREADONLY|OFN_ENABLESIZING|OFN_FILEMUSTEXIST, strFilters, this);

	//fileDlg.m_pOFN->nFilterIndex = 1;
	//fileDlg.m_pOFN->lpstrTitle = _T("Open Title Config Files");
	fileDlg.m_pOFN->lpstrInitialDir = m_strInitialConfigDir;
	if( fileDlg.DoModal ()==IDOK )
	{
		m_strConfigFileName = fileDlg.GetPathName();
		TCHAR drive[_MAX_DRIVE];
		TCHAR dir[_MAX_DIR];
		TCHAR fname[_MAX_FNAME];
		TCHAR ext[_MAX_EXT];

		_tsplitpath_s(m_strConfigFileName, drive, dir, fname, ext); 
		m_strInitialConfigDir = drive;
		m_strInitialConfigDir += dir;

		UpdateStatus();
		OnBnClickedLoadConfig();
	}
}

void CTitleRunTimeTestDlg::OnBnClickedBrowseTask()
{
	if (m_titleObject == NULL) return;
	CString strFilters;
	CString strTaskName;
	try {
		 strFilters = (LPCTSTR)m_titleObject->GetTaskFileMask();
		 strTaskName = (LPCTSTR)m_titleObject->GetTaskFileName();
	} catch (_com_error& err) {
		ShowError(err);
		return;
	}

	strFilters += _T("All Files (*.*)|*.*||");

	// Create an Open dialog; the default file name extension is ".xml".
	CFileDialog fileDlg (TRUE, NULL, strTaskName, OFN_FILEMUSTEXIST| OFN_HIDEREADONLY | OFN_ENABLESIZING, strFilters, this);

	if (strTaskName.IsEmpty()) {
		fileDlg.m_pOFN->lpstrInitialDir = m_strInitialTaskDir;
	} else {
		//ATL::CPath path(strTaskName);
		//fileDlg.m_pOFN->lpstrInitialDir = path.RemoveFileSpec()
	}
	// Display the file dialog. When user clicks OK, fileDlg.DoModal() 
	// returns IDOK.
	if( fileDlg.DoModal ()==IDOK )				
	{
		m_strTaskFileName = fileDlg.GetPathName();
		TCHAR drive[_MAX_DRIVE];
		TCHAR dir[_MAX_DIR];
		TCHAR fname[_MAX_FNAME];
		TCHAR ext[_MAX_EXT];

		_tsplitpath_s(m_strTaskFileName, drive, dir, fname, ext); 
		m_strInitialTaskDir = drive;
		m_strInitialTaskDir += dir;
	}
	UpdateStatus();
}

void CTitleRunTimeTestDlg::OnBnClickedLoadConfig()
{
	//ASSERT(m_titleMgr != NULL);
	BOOL loadDll = m_LoadAsDll.GetCheck();
	ClearAll();
	if (m_dll != loadDll) {
		m_titleMgr = NULL;
		m_dll = loadDll;
	}
	if (m_titleMgr == NULL) {
		if (!CreateTitleMgr()) {
			return;
		}
	}
	if (m_titleMgr == NULL) return;
	if (!m_strConfigFileName.IsEmpty()) {
		try {
			//ClearAll();
           
            //SetThreadLocale(MAKELCID(0x409, SORT_DEFAULT));
			SetThreadLocale((LCID)m_Lang.GetItemData(m_Lang.GetCurSel()));

			ISLTMTitleScriptDebugPtr iDebug = m_titleMgr;
			if (iDebug != NULL) {
				bool debugScript = ((CButton*)GetDlgItem(IDC_DEBUG_SCRIPT_ENABLE))->GetCheck() == BST_CHECKED;
				iDebug->EnableScriptTrace = debugScript;
			}


            ISLTMTitleRunTimeMgr4Ptr pMgr4(m_titleMgr);
			long currEngine = (long)m_BoardsList.GetItemData(m_BoardsList.GetCurSel());
            if (pMgr4 != NULL) {
                CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_ZORDER);
                int zOrder = (int)pCB->GetItemData(pCB->GetCurSel());
                //pMgr4->Init(
                //    _bstr_t(m_strConfigFileName), 
                //    (long)m_BoardsList.GetItemData(m_BoardsList.GetCurSel()),
                //    (GUID*)m_TargetList.GetItemDataPtr(m_TargetList.GetCurSel()),
                //    zOrder);
				pMgr4->Init(
					_bstr_t(m_strConfigFileName),
					(long)m_engines[currEngine].Index(),
					&m_engines[currEngine].Guid(),
					zOrder);
			}
            else {
			    //m_titleMgr->Init(
				   // _bstr_t(m_strConfigFileName), 
				   // (long)m_BoardsList.GetItemData(m_BoardsList.GetCurSel()),
				   // (GUID*)m_TargetList.GetItemDataPtr(m_TargetList.GetCurSel()));
				m_titleMgr->Init(
					_bstr_t(m_strConfigFileName),
					(long)m_engines[currEngine].Index(),
					&m_engines[currEngine].Guid());

            }
			int numObj = m_titleMgr->NumObjects;
			for (int i = 0; i < numObj; ++i) {
				ISLTMTitleRunTime3Ptr iRunTime = m_titleMgr->GetRunTimeInterface(i);
				m_aTitleObjects.Add(iRunTime);
				int index = m_TitleObjectsList.AddString(iRunTime->Name);
				m_TitleObjectsList.SetItemData(index, i);
			}
			m_TitleObjectsList.SetCurSel(0);
			//m_TitleObjectsList.GetText(0, m_SelectedName);
			//m_titleObject = m_aTitleObjects[0];
			OnLbnSelchangeObjectsList();

            double vol = (double)((CSliderCtrl*)GetDlgItem(IDC_SLIDER_VOLUME))->GetPos() / 100.0;
            ISLTMTitleAudioPtr audio = m_titleMgr;
            if (audio != NULL) {
                audio->Volume = vol;
            }
            OnBnClickedCheckMute();
			OnBnClickedCheckNotify();

		} 
        catch (_com_error& err) {
			ShowError(err);
			ClearAll();
		}
        catch (...) {
            MessageBox(_T("Unknown ERROR"));
            ClearAll();
        }
	}
	UpdateStatus();
}


void CTitleRunTimeTestDlg::OnBnClickedLoadTask()
{
	if (m_titleObject == NULL) return;
	try {
		m_titleObject->LoadTask(_bstr_t(m_strTaskFileName));
	} catch (_com_error& err) {
		ShowError(err);
	}
	UpdateStatus();
}

void CTitleRunTimeTestDlg::OnBnClickedStart()
{
	if (m_titleObject != NULL) {
		try {
			UpdateData();
			//if (m_StartDelay < 0) m_StartDelay = 0;
			m_titleObject->Start(-m_StartDelay, m_StartDuration);
		} catch (_com_error& err) {
			ShowError(err);
		}
	}
	UpdateStatus();
}

void CTitleRunTimeTestDlg::OnBnClickedStop()
{														
	if (m_titleObject != NULL) {
		try {
			UpdateData();
			if (m_StopDelay < 0) m_StopDelay = 0;
			m_titleObject->Stop(-m_StopDelay, m_StopDuration);
		} catch (_com_error& err) {
			ShowError(err);
		}
	}
	UpdateStatus();
}

void CTitleRunTimeTestDlg::OnBnClickedAbort()
{
	if (m_titleObject != NULL) {
		try {
			m_titleObject->Abort(m_AbortDuration);
		} catch (_com_error& err) {
			ShowError(err);
		}
	}
	UpdateStatus();
}

void CTitleRunTimeTestDlg::OnBnClickedStartStop()
{
	if (m_titleObject != NULL) {
		try {
			UpdateData();
			double stopDelay = m_StopDelay;//-max(0, m_StopDelay);
            double currTime = 0;
            double restTime = 0;
            double allDuration = 0;
            LONG loopped = FALSE;
			m_titleObject->GetPlayInfo(&currTime, &restTime, &allDuration, &loopped);
            if (m_useRestForStartStop) {
				stopDelay = restTime;//-max(0, restTime);
			}
            TRACE(_T("CTitleRunTimeTestDlg Start/Stop startDelay:%f startDuration:%f stopDelay:%f stopDuration:%f currTime:%f restTime:%f allDuration:%f\n"), 
				-m_StartDelay, m_StartDuration, -stopDelay, m_StopDuration, currTime, restTime, allDuration);
            SLTMRunTimeStatus status = m_titleObject->Status;
            if (status == SLTMRunTimeStatus_eStopped) 
            {
                TRACE(_T("CTitleRunTimeTestDlg Start atTime:%f\n"), currTime + m_StartDelay);
                m_titleObject->Start(currTime + m_StartDelay, m_StartDuration);
                stopDelay += m_StartDelay;
            }
            status = m_titleObject->Status;
            if (status == SLTMRunTimeStatus_eStarting || status == SLTMRunTimeStatus_eRunning) 
            {
                TRACE(_T("CTitleRunTimeTestDlg Stop atTime:%f\n"), currTime + stopDelay);
                m_titleObject->Stop(currTime + stopDelay, m_StopDuration);
            }
		} catch (_com_error& err) {
			ShowError(err);
		}
	}
	UpdateStatus();
}


void CTitleRunTimeTestDlg::OnBnClickedStartAll()
{
	if (m_titleObject != NULL) {
		UpdateData();
		for (int i = 0; i < m_aTitleObjects.GetCount(); i++) {
			try {
				m_aTitleObjects[i]->Start(-m_StartDelay, m_StartDuration);
			}
			catch (_com_error&) {
				//ShowError(err);
			}
		}
	}
	UpdateStatus();
}

void CTitleRunTimeTestDlg::OnBnClickedStopAll()
{
	if (m_titleObject != NULL) {
		UpdateData();
		for (int i = 0; i < m_aTitleObjects.GetCount(); i++) {
			try {
				m_aTitleObjects[i]->Stop(-m_StopDelay, m_StopDuration);
			} catch (_com_error&/* err*/) {
				//ShowError(err);
			}
		}
	}
	UpdateStatus();
}

void CTitleRunTimeTestDlg::OnBnClickedAbortAll()
{
	if (m_titleObject != NULL) {
		UpdateData();
		for (int i = 0; i < m_aTitleObjects.GetCount(); i++) {
			try {
				m_aTitleObjects[i]->Abort(m_AbortDuration);
			} catch (_com_error& err) {
				ShowError(err);
			}
		}
	}
	UpdateStatus();
}

void CTitleRunTimeTestDlg::OnBnClickedUninit()
{
	ClearAll();
	m_titleMgr = NULL;
	UpdateStatus();
}

void CTitleRunTimeTestDlg::UpdateStatus(void)
{
	m_CurrTime = "";
	m_RestTime = "";
	m_Duration = "";
	m_Loopped = "";
	if (m_titleObject == NULL) {
		m_strStatus = "Not Initialized";
	} else {
		SLTMRunTimeStatus status =  SLTMRunTimeStatus_eNone;
		try {
			 status = m_titleObject->Status;
			 double currTime;
			 double restTime;
			 double allDuration;
			 LONG loopped;
			 double intpart = 0;
			 m_titleObject->GetPlayInfo(&currTime, &restTime, &allDuration, &loopped);
			 currTime += 0.0001;
			 restTime += 0.0001;
			 allDuration += 0.0001;
			 m_CurrTime.Format(_T("%d:%02d.%03d"), long(currTime/60), long(currTime)%60, long(modf(currTime,&intpart)*1000.0 /*+ 0.1*/));
			 m_RestTime.Format(_T("%d:%02d.%03d"), long(restTime/60), long(restTime)%60, long(modf(restTime,&intpart)*1000.0 /*+ 0.1*/));
			 m_Duration.Format(_T("%d:%02d.%03d"), long(allDuration/60), long(allDuration)%60, long(modf(allDuration,&intpart)*1000.0 /*+ 0.1*/));
			 m_Loopped.Format(_T("%ws"), loopped != FALSE?_T("Loop"):_T("No Loop"));
			 ISLTMTitleCommonAlphaPtr iCommonAlpha = m_titleObject;
			 if (iCommonAlpha != NULL) {
				 m_currAlpha = (BYTE)iCommonAlpha->Alpha;
			 }
		} catch (_com_error& err) {
			if (err.Error() == E_POINTER) {
				m_strStatus = "Config not loaded";
				UpdateData(FALSE);
				return;
			}
		}
		switch(status) {
		case SLTMRunTimeStatus_eNone:
			m_strStatus = "None";
			break;
		case SLTMRunTimeStatus_ePreparing:
			m_strStatus = "Preparing";
			break;
		case SLTMRunTimeStatus_eStopped:
			m_strStatus = "Stopped";
			break;
		case SLTMRunTimeStatus_eStarting:
			m_strStatus = "Starting";
			break;
		case SLTMRunTimeStatus_eRunning:
			m_strStatus = "Running";
			break;
		case SLTMRunTimeStatus_eStopping:
			m_strStatus = "Stopping";
			break;
		default:
			m_strStatus = _T("Unknown");
		}
		if (m_bTestActive) {
			CString str; str.Format(_T(" + %d"), m_testCount);
			m_strStatus += str;
		}
	}
	UpdateData(FALSE);
}

void CTitleRunTimeTestDlg::OnBnClickedOk()
{
	//ClearAll();
	//m_titleMgr = NULL;
	//OnOK();
}

void CTitleRunTimeTestDlg::OnLbnSelchangeObjectsList()
{
	UpdateData();
	int index = m_TitleObjectsList.GetCurSel();
	index = (int)m_TitleObjectsList.GetItemData(index);
	m_titleObject = m_aTitleObjects[index];
	//m_TitleObjectsList.GetText(index, m_SelectedName);
	m_SelectedName = (LPTSTR)m_titleObject->GetName();
	m_strTaskFileName = (LPTSTR)m_titleObject->GetTaskFileName();
	GetDlgItem(IDC_FLIP_FLOP)->EnableWindow(CheckPreload());
	UpdateStatus();
}

void CTitleRunTimeTestDlg::OnClose()
{
	if (m_TimerId > 0) {
		KillTimer(m_TimerId);
		m_TimerId = 0;
	}
	ClearAll();
	m_titleMgr = NULL;
	CDialog::OnClose();
}

BOOL CTitleRunTimeTestDlg::CreateGuardEvent() 
{
	m_guardEvent.Free();

	HRESULT hr = S_OK;
	GUID uuid;
	hr = CoCreateGuid(&uuid);
	if (FAILED(hr)) {
		return hr;
	}
	int len = StringFromGUID2(uuid, m_guardName.GetBufferSetLength(100), 100);
	m_guardName.ReleaseBuffer(len - 1);
	if (len <= 0) {
		return E_OUTOFMEMORY;
	}

	//RPC_STATUS rpcerr = UuidCreateSequential(&uuid);
	//if (uuid == GUID_NULL) {
	//	return HRESULT_FROM_WIN32(rpcerr);
	//}

	//RPC_WSTR pname = NULL;
	//hr = HRESULT_FROM_WIN32(UuidToString(&uuid, &pname));
	//if (FAILED(hr)) {
	//	return hr;
	//}
	//m_guardName = (LPWSTR)pname;
	//RpcStringFree(&pname);
	//pname = NULL;

	m_guardName.Trim(L"{}");
	if (!m_guardName.IsEmpty()) {
		m_guardEvent = CAutoPtr<CEvent>(new CEvent(FALSE, TRUE, m_guardName));
	}

	return TRUE;
}
BOOL CTitleRunTimeTestDlg::CreateTitleMgr() 
{
	HRESULT hr = S_OK;
	if (m_titleMgr == NULL) {
		GUID clsid = m_dll ? CLSID_TitleProjectMgr : CLSID_SLTitleProjectMgr;
		//HRESULT hr = m_titleMgr.CreateInstance(CLSID_TitleProjectMgr);
		//HRESULT hr = m_titleMgr.CreateInstance(__uuidof(SLTitleProjectMgr));
		//hr = CoCreateInstance(clsid, NULL, CLSCTX_INPROC | CLSCTX_LOCAL_SERVER, m_titleMgr.GetIID(), reinterpret_cast<void**>(&m_titleMgr));
		hr = m_titleMgr.CreateInstance(clsid, NULL, CLSCTX_INPROC | CLSCTX_LOCAL_SERVER);
		if (FAILED(hr)) {
			CString msg; msg.Format(_T("Can't Create %s\n\r%s"), m_dll ? _T("InProc(DLL) server") : _T("OutProc(EXE) server"), GetErrorMessage(hr));
			MessageBox(msg, _T("Can't Create TitleProjectMgr"), MB_OK | MB_ICONERROR);
			return FALSE;
		}
	}
	ISLTMTitlePrimaryInitPtr primaryInit = m_titleMgr;
	if (primaryInit != NULL) {
		hr = primaryInit->raw_PrimaryInit(GetThreadLocale(), _bstr_t(m_guardName));
		if (FAILED(hr)) {
			MessageBox(GetErrorMessage(hr), _T("PrimaryInit"), MB_OK | MB_ICONERROR);
			return FALSE;
		}
	}

	return TRUE;
}

// Clear all Title Objects
void CTitleRunTimeTestDlg::ClearAll(void)
{
	if (m_titleMgr != NULL) {
		m_titleObject = NULL;
		if (::IsWindow(m_TitleObjectsList.m_hWnd)) {
			while (m_TitleObjectsList.GetCount() != 0) {

				m_TitleObjectsList.DeleteString(0);
			}
		}
		SLTMRunTimeStatus allStatus = SLTMRunTimeStatus_eNone;
		for (int i = 0; i < m_aTitleObjects.GetCount(); i++) {
			SLTMRunTimeStatus status = SLTMRunTimeStatus_eNone;
			try {
				m_aTitleObjects[i]->get_Status(&status);
				if (status > allStatus) allStatus = status;
				m_aTitleObjects[i]->LoadTask(_T(""));
			}
			catch (...) {}
// 			if (status == SLTMRunTimeStatus_eRunning) {
// 				m_aTitleObjects[i]->Abort(0);
// 			}
			m_aTitleObjects[i] = NULL;
		}
		m_aTitleObjects.RemoveAll();
		if (allStatus == SLTMRunTimeStatus_eRunning) Sleep(1000);
		try {
			m_titleMgr->Uninit();
		} catch (_com_error& err) {
			ShowError(err);
			HRESULT __hr = err.Error();
			if (__hr == HRESULT_FROM_WIN32(RPC_S_SERVER_UNAVAILABLE) /* 0x800706BA */
				|| __hr ==  RPC_E_DISCONNECTED /* 0x80010108*/)
			{
				try { m_titleMgr = NULL; } catch (...) {}
			}
		}
	}
}

afx_msg void CTitleRunTimeTestDlg::OnTimer(UINT_PTR nIDEvent)
{
	static bool reenter = false;
	if (!reenter && m_TimerId > 0) {
		reenter = true;
		try {
			UpdateData();
			DoTest();
			UpdateStatus();
		} catch (...) {
		}
		reenter = false;
	}
	CDialog::OnTimer(nIDEvent);
}

void CTitleRunTimeTestDlg::DoTest()
{
	if (m_titleObject == NULL) return;
	if (m_bTestActive && --m_tickCounter <= 0) {
		m_testCount++;
		m_tickCounter = 1;
		//OnBnClickedLoadTask();
		//Sleep(40);
		try {
			UpdateData();
			//m_titleObject->Start(-m_StartDelay, m_StartDuration);
			LONG looped = FALSE;
            double duration = 0;
			HRESULT hr = S_OK;
            BSTR bstr = NULL;
			m_titleObject->raw_GetTaskInfoNew(_bstr_t(m_strTaskFileName),&looped, &hr, &bstr, &duration);
            _bstr_t errorMsg; errorMsg.Attach(bstr);

            //CComBSTR errorMsg;
            //CComBSTR taskName(m_strTaskFileName);
            //m_titleObject->raw_GetTaskInfoNew(taskName,&looped, &hr, &errorMsg, &duration);
            ////CComBSTR errBSTR; errBSTR.Attach(errorMsg);
		} catch (_com_error& err) {
			ShowError(err);
		}

	}
}


BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	TCHAR  szFullPath[256];
	DWORD dwVerHnd;
	DWORD dwVerInfoSize;
	// Get version information from the application
	
	GetModuleFileName(AfxGetApp()->m_hInstance, szFullPath, sizeof(szFullPath));
	dwVerInfoSize = GetFileVersionInfoSize(szFullPath, &dwVerHnd);

	if (dwVerInfoSize)
	{
		// If we were able to get the information, process it:
		LPSTR  pVersion;
		CString strRoot;//(_T("\\StringFileInfo\\040904b0\\"));
		CString strGetName;
		CString strResult("");

		CHAR*	pStr;
		UINT	cStr;
		BOOL	fRet;

		pVersion = new char[dwVerInfoSize];
		GetFileVersionInfo(szFullPath, dwVerHnd, dwVerInfoSize, pVersion);

		// Structure used to store enumerated languages and code pages.
		struct LANGANDCODEPAGE {
			WORD wLanguage;
			WORD wCodePage;
		} *lpTranslate;
		UINT cbTranslate;

		// Read the list of languages and code pages.
		VerQueryValue(pVersion, 
			CString(TEXT("\\VarFileInfo\\Translation")),
			(LPTSTR*)&lpTranslate,
			&cbTranslate);

		WORD wLangId = LANGIDFROMLCID(GetThreadLocale());
		// Read the file description for each language and code page.

		if (cbTranslate >= sizeof(struct LANGANDCODEPAGE)) {
			strRoot.Format(_T("\\StringFileInfo\\%04x%04x\\"), 				
						lpTranslate[0].wLanguage,
						lpTranslate[0].wCodePage);
			for (UINT i = 1; i < (cbTranslate/sizeof(struct LANGANDCODEPAGE)); i++ ) {
				if (lpTranslate[i].wLanguage == wLangId) {
					strRoot.Format(_T("\\StringFileInfo\\%04x%04x\\"), 				
						lpTranslate[i].wLanguage,
						lpTranslate[i].wCodePage);

				}
			} 
		}


		//strGetName = "ProductName";
		strGetName = "FileDescription";
		strGetName = strRoot + strGetName;

		fRet = VerQueryValue(pVersion, strGetName, &pStr, &cStr);
		if (fRet) {
			CString str(pStr);
			SetDlgItemText( ID_PRODUCT, str );
		}

		strResult = "Version: ";

		//strGetName = "FileVersion";
		strGetName = "ProductVersion";
		strGetName = strRoot + strGetName;

		fRet = VerQueryValue(pVersion, strGetName, &pStr, &cStr);
		if (fRet) {
			strResult += pStr;
		}

		strGetName = "\\";		// Fixed File info

		fRet = VerQueryValue(pVersion, strGetName, &pStr, &cStr);
		if (fRet) {
			if ( ((VS_FIXEDFILEINFO*)pStr)->dwFileFlags & VS_FF_PRERELEASE) 
				strResult += " (Beta)";
			if ( ((VS_FIXEDFILEINFO*)pStr)->dwFileFlags & VS_FF_DEBUG) 
				strResult += " Debug";
			//else 
			//	strResult += " Release";
		}

		SetDlgItemText( ID_VERSION, strResult );


		strResult = "";
		strGetName = "LegalCopyright";
		strGetName = strRoot + strGetName;

		fRet = VerQueryValue(pVersion, strGetName, &pStr, &cStr);
		if (fRet) {
			strResult = pStr;
		}

		SetDlgItemText( ID_COPYRIGHT, strResult );

		delete pVersion;
	}

	return TRUE;
}

void CTitleRunTimeTestDlg::OnBnClickedGetTaskInfo()
{
	if (m_titleObject == NULL) return;
	try {
		LONG looped = FALSE;
		HRESULT hr = S_OK;
		_bstr_t errorMsg;
		double duration = 0;
        EMediaPresent mediaPresent = EMediaPresent_MediaPresentNone;
        ISLTMTitleRunTime4Ptr runTime4 = m_titleObject;
        if (runTime4 != NULL) {
            runTime4->raw_GetTaskInfoEx(_bstr_t(m_strTaskFileName),&looped, &hr, &(errorMsg.GetBSTR()), &mediaPresent, &duration);
        }
        else {
		    m_titleObject->raw_GetTaskInfoNew(_bstr_t(m_strTaskFileName),&looped, &hr, &(errorMsg.GetBSTR()), &duration);
        }
		CString str;
		if (hr == S_OK || (hr == S_FALSE && errorMsg.length() == 0)) {
			str.Format(_T("Info from file: \n'%ws'\n duration: %f\n duration: %d min %d sec %03d mSec\n Loopped: %ws\n"), 
				m_strTaskFileName, duration, long(duration/60), long(duration)%60, long(fmod(duration,1)*1000.0 + 0.1), looped!=FALSE?_T("Yes"):_T("No"));
            if (mediaPresent != EMediaPresent_MediaPresentNone) {
                str.AppendFormat(_T(" VideoPresent: %s\n AudioPresent: %s\n AlphaPresent: %s\n")
                    , (mediaPresent & EMediaPresent_VideoPresent) != 0?_T("Yes"):_T("No")
                    , (mediaPresent & EMediaPresent_AudioPresent) != 0?_T("Yes"):_T("No")
                    , (mediaPresent & EMediaPresent_AlphaPresent) != 0?_T("Yes"):_T("No"));
            }
            else {
                str.Append(_T("MediaPresent: Unknown\n"));
            }
		}
		else {
			CString strErr((LPCTSTR)errorMsg);
			LimitLines(strErr);
			str.Format(_T("Info from file: \n'%ws'\n duration: %f\n duration: %d min %d sec %03d mSec\n Loopped: %ws\n\nErrors hr:%#08x\n%ws"), 
				m_strTaskFileName, duration, long(duration/60), long(duration)%60, long(fmod(duration,1)*1000.0 + 0.1), looped!=FALSE?_T("Yes"):_T("No"), hr, (LPCTSTR)strErr);
		}
		MessageBox(str, _T("TaskInfo"), MB_OK | MB_ICONINFORMATION);
	} catch (_com_error& err) {
		ShowError(err);
	}
	UpdateStatus();

}

void CTitleRunTimeTestDlg::OnCbnSelchangeBoardsList()
{
	OnBnClickedLoadConfig();
}

void CTitleRunTimeTestDlg::OnBnClickedSetAlpha()
{
	if (m_titleObject != NULL) {
		try {
			UpdateData();
			ISLTMTitleCommonAlphaPtr iCommonAlpha = m_titleObject;
			if (iCommonAlpha != NULL) {
				if (m_alphaDelay == 0 && m_alphaDuration == 0) {
					iCommonAlpha->Alpha = m_alphaEdit;
				}
				else {
					iCommonAlpha->Interpolate(-m_alphaDelay, m_alphaDuration, m_alphaEdit);
				}
			}
		} catch (_com_error& err) {
			ShowError(err);
		}
	}
	UpdateStatus();
}

//void CTitleRunTimeTestDlg::OnCbnSelchangeTargetList()
//{
//	int sel = m_BoardsList.GetCurSel();
//	FillBoardList(sel);
//
//	OnBnClickedLoadConfig();
//}

void CTitleRunTimeTestDlg::OnBnClickedShowProperties()
{
	if (m_titleObject != NULL) {
		try {
			UpdateData();
			ISLTMTitleObjectPropertiesPtr iProperties = m_titleObject;
			if (iProperties != NULL) {
				//iProperties->ShowDialog((long)m_hWnd);
				iProperties->ShowDialog(0);
			}
		} catch (_com_error& err) {
			ShowError(err);
		}
	}
}

void CTitleRunTimeTestDlg::OnLbnDblclkObjectsList()
{
	if (m_titleObject != NULL) {
		try {
			UpdateData();
			ISLTMTitleObjectPropertiesPtr iProperties = m_titleObject;
			if (iProperties != NULL) {
				iProperties->Show(PtrToLong(m_hWnd));
				//iProperties->Show(0);
			}
		} catch (_com_error& err) {
			ShowError(err);
		}
	}
}


void CTitleRunTimeTestDlg::OnBnClickedCreateLog()
{
    CButton* createLog = (CButton*)GetDlgItem(IDC_CREATE_LOG);
    if (createLog->GetCheck() == BST_CHECKED) {
        try {
            ISLLSLoggingPtr iSlLog; iSlLog.CreateInstance(CLSID_SLLSLogging);
            ISLLSLogSenderPtr iSlLogSender; iSlLogSender.CreateInstance(CLSID_SLLSLogSender);
            iSlLogSender->SetOwner(_T("TitleRunTimeTest"));
            iSlLog->SetParent(iSlLogSender);
            iSlLog->SetSource(_bstr_t(_T("TitleRunTimeTest")));
            ISLTMTitleLogPtr iTitleLog = m_titleMgr;
            iTitleLog->SetLogObject(iSlLog);
        }
        catch (_com_error& err) {
            ShowError(err);
        }
    }
    else {
        ISLTMTitleLogPtr iTitleLog = m_titleMgr;
        iTitleLog->SetLogObject(NULL);
    }
}

void CTitleRunTimeTestDlg::OnCbnSelchangeZorder()
{
    // TODO: Add your control notification handler code here
}

void CTitleRunTimeTestDlg::OnBnClickedSuppressWarning()
{
    SuppressWarning();
}

void CTitleRunTimeTestDlg::SuppressWarning()
{
    if (m_titleMgr != NULL) {
        CComboBox* ignoreCtrl = (CComboBox*)GetDlgItem(IDC_IGNORE_CANCEL);
        bool ignoreAnswer = ignoreCtrl->GetCurSel() == 0;
        bool suppress = ((CButton*)GetDlgItem(IDC_SUPPRESS_WARNING))->GetCheck() == BST_CHECKED;

        ISLTMWarningsPtr iWarnings = m_titleMgr;
        iWarnings->SuppressWarningBoxes(suppress, ignoreAnswer);
    }
}

void CTitleRunTimeTestDlg::OnCbnSelchangeIgnoreCancel()
{
    SuppressWarning();
}

void CTitleRunTimeTestDlg::OnBnClickedTest()
{
	m_bTestActive = !m_bTestActive;
	m_tickCounter = 0;
	m_testCount = 0;
}

void CTitleRunTimeTestDlg::OnBnClickedDebugScriptEnable()
{
	OnBnClickedLoadConfig();
}

void CTitleRunTimeTestDlg::OnBnClickedEditNotify()
{
	CNonifyEditor edit;
	CString comments;
	edit.Init(m_notifyFile, m_notifyDuration, m_notifyComments);

	edit.DoModal();
	m_notifyFile = edit.m_fileName;
	m_notifyDuration = edit.m_duration;
	comments = edit.m_comments;
	int currPos = 0;
	CString token = comments.Tokenize(_T("\r\n"), currPos);
	while (!token.IsEmpty()) {
		token.Trim(_T("\r\n"));
		token.Trim();
		if (!token.IsEmpty()) {
			m_notifyComments += token + _T("\r\n");
		}
		token = comments.Tokenize(_T("\r\n"), currPos);
	}
	m_notifyComments = comments;

}


//   
//<titletime start="16131.599" crossfade="0.1" /> 	
//<movie file="E:\Video\about_programmers.mpg" crossfade="0.10" duration="0:01:00.26" file_duration="0:01:00.26" /> 	
//<comment title="annonce :  " /> 	
//<comment title="mclipinfo SL_Muz_info.avi" /> 	
//<comment title="mclipinfo   comments||(c) Microsoft" /> 	
void CTitleRunTimeTestDlg::OnBnClickedSendNotify()
{
	if (m_titleObject != NULL && m_notifyChecked > 0) {
		try {
			UpdateData();
			double currTime;
			double restTime;
			double allDuration;
			LONG loopped;
			m_titleObject->GetPlayInfo(&currTime, &restTime, &allDuration, &loopped);
			CString notifyStr = FormatNotify(m_notifyFile, currTime, m_notifyDuration, m_notifyComments);
			for (int i = 0; i < m_aTitleObjects.GetCount(); i++) {
				try {
					ISLTMTitleBackGroundNotifyPtr iNotify = m_aTitleObjects[i];
					if (iNotify != NULL) {
						iNotify->OnBackGroundNotify((LPCTSTR)notifyStr);
					}
				}
				catch (_com_error&) {
					//ShowError(err);
				}
			}
		} catch (_com_error&) {
		}
	}
	UpdateStatus();
}

void CTitleRunTimeTestDlg::OnBnClickedCheckNotify()
{
	if (m_titleObject != NULL) {
		UpdateData();
		//m_notifyStatus = _T("Unknown");
		bool need = false;
		for (int i = 0; i < m_aTitleObjects.GetCount(); i++) {
			try {
				ISLTMTitleBackGroundNotifyPtr iNotify = m_aTitleObjects[i];
				if (iNotify != NULL) {
					need = need || iNotify->NeedNotify() != FALSE;
				}
			}
			catch (_com_error&) {
				//ShowError(err);
			}
		}
		m_notifyChecked = (long)need;
		GetDlgItem(IDC_SEND_NOTIFY)->EnableWindow((BOOL)need);
		GetDlgItem(IDC_SEND_NOTIFY_LIVE)->EnableWindow((BOOL)need);
		//m_notifyStatus = need? _T("Need"): _T("No need");
	}
	UpdateStatus();
}

//<titletime start="16201.639" crossfade="0.1" /> 	
//<live channel="1" crossfade="0.10" /> 	
void CTitleRunTimeTestDlg::OnBnClickedSendNotifyLive()
{
	if (m_titleObject != NULL && m_notifyChecked > 0) {
		try {
			UpdateData();
			double currTime;
			double restTime;
			double allDuration;
			LONG loopped;
			m_titleObject->GetPlayInfo(&currTime, &restTime, &allDuration, &loopped);
			CString notifyStr;
			notifyStr.Format(_T("<titletime start=\"%1.03f\" crossfade=\"0.1\" />\n<live channel=\"1\" crossfade=\"0.10\" />"), currTime);
			for (int i = 0; i < m_aTitleObjects.GetCount(); i++) {
				try {
					ISLTMTitleBackGroundNotifyPtr iNotify = m_aTitleObjects[i];
					if (iNotify != NULL) {
						iNotify->OnBackGroundNotify((LPCTSTR)notifyStr);
					}
				}
				catch (_com_error&) {
					//ShowError(err);
				}
			}
		} catch (_com_error&) {
		}
	}
	UpdateStatus();
}

typedef BOOL(WINAPI *LPFN_ISWOW64PROCESS) (HANDLE, PBOOL);

LPFN_ISWOW64PROCESS fnIsWow64Process;

bool IsWow64()
{
    BOOL bIsWow64 = FALSE;

    //IsWow64Process is not available on all supported versions of Windows.
    //Use GetModuleHandle to get a handle to the DLL that contains the function
    //and GetProcAddress to get a pointer to the function if available.

    fnIsWow64Process = (LPFN_ISWOW64PROCESS)GetProcAddress(
        GetModuleHandle(TEXT("kernel32")), "IsWow64Process");

    if (NULL != fnIsWow64Process)
    {
        if (!fnIsWow64Process(GetCurrentProcess(), &bIsWow64))
        {
            //handle error
        }
    }
    return bIsWow64 != FALSE;
}

void CTitleRunTimeTestDlg::FillBoardList(int sel)
{

	m_BoardsList.ResetContent();
	ISLTMEnumVideoPlayer4TEPtr iEnum;
	HRESULT hr = iEnum.CreateInstance(CLSID_SLTMEnumVideoPlayer4TE);
	if (SUCCEEDED(hr)) {
		int cnt = iEnum->Count;
		for (int i = 0; i < cnt; ++i) {
			m_engines.Add(CEngine(iEnum->Name[i], iEnum->type[i], iEnum->index[i]));
		}
		for (int i = 0; i < cnt; ++i) {
			m_BoardsList.SetItemData(m_BoardsList.AddString(m_engines[i].Name()), i);
		}
	}
	if (sel <= m_BoardsList.GetCount()) {
		m_BoardsList.SetCurSel(sel);
	}
	else {
		m_BoardsList.SetCurSel(0);
	}
}


//void CTitleRunTimeTestDlg::FillBoardList( int sel )
//{
//	m_BoardsList.ResetContent();
//	try {
//        long boardCount = GetFD300BoardCount();
//        if (boardCount > 0 && m_TargetList.GetCurSel() < m_fd300TargetCount) {
//            for (int i = 0; i < boardCount; ++i) {
//                CString name; name.Format(_T("Board #%d"), i + 1);
//                m_BoardsList.SetItemData(m_BoardsList.AddString(name), i);
//            }
//        }
//	} 
//	catch (...) {
//	}
//
//	if (m_BoardsList.GetCount() == 0)  {
//		for (int i = 0; i < 20; ++i) {
//			CString name; name.Format(_T("TitleEngine #%d"), i);
//			m_BoardsList.SetItemData(m_BoardsList.AddString(name), i);
//		}
//        //if (m_TargetList.GetCurSel() < m_fd300TargetCount) {
//        //    m_TargetList.SetCurSel(m_fd300TargetCount); // for FDExt boards
//        //}
//	}
//	if (sel <= m_BoardsList.GetCount()) {
//		m_BoardsList.SetCurSel(sel);
//	}
//	else {
//		m_BoardsList.SetCurSel(0);
//	}
//}
//
//long CTitleRunTimeTestDlg::GetFD300BoardCount()
//{
//    if (m_fd300BoardCount < 0) { //   
//        try {
//            m_fd300BoardCount = 0;
//            if (!IsWow64()) { //    x32
//
//                SLTMSRVDLib::ISLTMSrvPtr psIServer;
//                HRESULT hr = psIServer.CreateInstance(CLSID_SLTMSrv);
//
//                if (SUCCEEDED(hr)) {
//                    hr = psIServer->get_BoardsCount(&m_fd300BoardCount);
//                }
//                if (FAILED(hr)) {
//                    m_fd300BoardCount = 0;
//                }
//            }
//        }
//        catch (...) {
//            m_fd300BoardCount = 0;
//        }
//    }
//    return m_fd300BoardCount;
//}


void CTitleRunTimeTestDlg::OnCbnSelchangeLang()
{
    UpdateData();
	SetThreadLocale((LCID)m_Lang.GetItemData(m_Lang.GetCurSel()));
    m_currLang = GetCurrentLocaleName();
    UpdateData(FALSE);
	ClearAll();
	//m_titleMgr = NULL;
	CreateTitleMgr();

	OnBnClickedLoadConfig();
}

CString CTitleRunTimeTestDlg::GetCurrentLocaleName()
{
    WCHAR name[LOCALE_NAME_MAX_LENGTH] = { 0 };
    if (GetLocaleInfo(GetThreadLocale(), LOCALE_SNATIVELANGNAME, name, LOCALE_NAME_MAX_LENGTH) <= 0) {
        return _T("Unknown");
    }
    return name;
}

void CTitleRunTimeTestDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
    CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
    CSliderCtrl *pSlider = (CSliderCtrl*)pScrollBar;

    if (pSlider != NULL)
    {
        //int minpos = 0, maxpos = 0;
        //pSlider->GetRange(minpos, maxpos);
        //int curpos = pSlider->GetPos();
        //switch (nSBCode)
        //{
        //case SB_LEFT:      // Scroll to far left.
        //    curpos = minpos;
        //    break;
        //case SB_RIGHT:      // Scroll to far right.
        //    curpos = maxpos;
        //    break;
        //case SB_ENDSCROLL:   // End scroll.
        //    break;
        //case SB_LINELEFT:      // Scroll left.
        //    if (curpos > minpos)
        //        curpos--;
        //    break;
        //case SB_LINERIGHT:   // Scroll right.
        //    if (curpos < maxpos)
        //        curpos++;
        //    break;
        //case SB_PAGELEFT:    // Scroll one page left.
        //    curpos = curpos - pSlider->GetPageSize();
        //    if (curpos < minpos)
        //        curpos = minpos;
        //    break;

        //case SB_PAGERIGHT:      // Scroll one page right.
        //    curpos = curpos + pSlider->GetPageSize();
        //    if (curpos > maxpos)
        //        curpos = maxpos;
        //    break;

        //case SB_THUMBPOSITION: // Scroll to absolute position. nPos is the position
        //    curpos = nPos;      // of the scroll box at the end of the drag operation.
        //    break;

        //case SB_THUMBTRACK:   // Drag scroll box to specified position. nPos is the
        //    curpos = nPos;     // position that the scroll box has been dragged to.
        //    break;
        //}

        //curpos = min(maxpos, max(minpos, curpos));
        //// Set the new position of the thumb (scroll box).
        //pSlider->SetPos(curpos);
        //double vol = (double)curpos / 100.0;
        double vol = (double)pSlider->GetPos() / 100.0;
        CString str; str.Format(_T("%0.2fdB"), vol);
        SetDlgItemText(IDC_EDIT_VOLUME, str);
        ISLTMTitleAudioPtr audio = m_titleMgr;
        if (audio != NULL) {
            audio->Volume = vol;
        }
    }

}


void CTitleRunTimeTestDlg::OnBnClickedCheckMute()
{
    CButton* mute = (CButton*)GetDlgItem(IDC_CHECK_MUTE);
    ISLTMTitleAudioPtr audio = m_titleMgr;
    if (audio != NULL && mute != NULL) {
        audio->Mute = (mute->GetCheck() == BST_CHECKED);
    }
}



void CTitleRunTimeTestDlg::OnBnClickedBoom()
{
	ISLTMTitleBoomPtr boom = m_titleMgr;
	if (boom != NULL) {
		boom->boom();
	}
}


void CTitleRunTimeTestDlg::OnBnClickedBoom2()
{
	ISLTMTitleBoomPtr boom = m_titleMgr;
	if (boom != NULL) {
		boom->threadBoom();
	}
}


void CTitleRunTimeTestDlg::OnBnClickedFlipFlop()
{
	if (CheckPreload()) {
		CFlipFlopDlg flipFlop(this);
		flipFlop.InitObject(m_titleObject);
		flipFlop.DoModal();
	}
}

bool CTitleRunTimeTestDlg::CheckPreload()
{
	ISLTMTitleRunTimePreloadPtr preload = m_titleObject;
	BOOL support = FALSE;
	try {
		if (preload != nullptr) {
			support = preload->CanPreload;
		}
	}
	catch (...) {}
	return support != FALSE;
}
