// TitleRunTimeTestDlg.h : header file
//

#pragma once
#include "afxwin.h"
//#include "afxtempl.h"
#include <math.h>
#include "FlipFlopDlg.h"

// CTitleRunTimeTestDlg dialog
class CTitleRunTimeTestDlg : public CDialog
{
// Construction
public:
    CTitleRunTimeTestDlg(CWnd* pParent = NULL);	// standard constructor
    virtual ~CTitleRunTimeTestDlg();

// Dialog Data
    enum { IDD = IDD_TITLERUNTIMETEST_DIALOG };

protected:
    virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
    HICON m_hIcon;

    // Generated message map functions
    virtual BOOL OnInitDialog();

    CString GetCurrentLocaleName();

    afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
    afx_msg void OnPaint();
    afx_msg HCURSOR OnQueryDragIcon();
    DECLARE_MESSAGE_MAP()
    ISLTMTitleRunTime3Ptr m_titleObject;
    ISLTMTitleRunTimeMgr2Ptr m_titleMgr;
    CArray<ISLTMTitleRunTime3Ptr> m_aTitleObjects;
public:
    static CString GetErrorMessage(ULONG err) 
    {
        LPVOID lpMsgBuf;
        if (!FormatMessage( 
            FORMAT_MESSAGE_ALLOCATE_BUFFER | 
            FORMAT_MESSAGE_FROM_SYSTEM | 
            FORMAT_MESSAGE_IGNORE_INSERTS,
            NULL,
            err,
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
            (LPTSTR) &lpMsgBuf,
            0,
            NULL ))
        {
            // Handle the error.
            return CString(_T("Unknown Error")); 
        }

        CString strMsg((LPCTSTR)lpMsgBuf);

        // Free the buffer.
        LocalFree( lpMsgBuf );
        return strMsg;
    }

    void LimitLines(CString& str, int limit = 50) {
        CString newStr;

        CString resToken;
        int curPos= 0;
        int count = 0;

        str += _T("\n");
        resToken= str.Tokenize(_T("\n"),curPos);
        while (/*resToken != _T("") &&*/ curPos != -1 && count++ < limit)
        {
            newStr += resToken + _T("\n");
            resToken= str.Tokenize(_T("\n"),curPos);
        }
        if (count >= limit && curPos != -1 /*&& resToken != _T("")*/) {
            newStr += _T("...\n");
        }
        str = newStr;
    } 

    void ShowError(_com_error& err) {
        if (err.Error() == 0x81234567) return;	//   ProcessedException 
        CString errStr = (LPCTSTR)err.Description();
        if (errStr.IsEmpty())
            errStr = err.ErrorMessage();

        LimitLines(errStr);

        MessageBox(errStr, err.Source().GetBSTR(), MB_OK| (err.Error() == 0x80042000? MB_ICONWARNING: MB_ICONERROR));
    }

    bool m_bTestActive;
    long m_tickCounter;
    long m_testCount;
    void DoTest();
    CString m_strConfigFileName;
    CString m_strTaskFileName;
    afx_msg void OnBnClickedBrowseConfig();
    afx_msg void OnBnClickedBrowseTask();
    afx_msg void OnBnClickedLoadConfig();
    afx_msg void OnBnClickedLoadTask();
    afx_msg void OnBnClickedStart();
    afx_msg void OnBnClickedStop();
    afx_msg void OnBnClickedAbort();
    afx_msg void OnBnClickedUninit();
    CString m_strStatus;
    void UpdateStatus(void);
	afx_msg void OnBnClickedOk();
	CListBox m_TitleObjectsList;
	afx_msg void OnLbnSelchangeObjectsList();
	afx_msg void OnClose();
protected:
    CString m_strInitialConfigDir;
    CString m_strInitialTaskDir;
	LONG m_notifyChecked;
	//CString m_notifyString;
	CString m_notifyFile;
	double m_notifyDuration;
	CString m_notifyComments;
	BOOL m_useRestForStartStop;
protected:
	BOOL CreateTitleMgr();
	BOOL CreateGuardEvent();
	CAutoPtr<CEvent> m_guardEvent;
	CStringW m_guardName;
	// Clear all Title Objects
    void ClearAll(void);
    double m_StartDelay;
    double m_StopDelay;
    double m_StartDuration;
    double m_StopDuration;
    double m_AbortDuration;
	UINT m_TimerId;
	CString m_CurrTime;
	CString m_RestTime;
	CString m_Duration;
	CString m_Loopped;
	CComboBox m_BoardsList;
	BYTE m_alphaEdit;
	BYTE m_currAlpha;
	double m_alphaDelay;
	double m_alphaDuration;
	//CComboBox m_TargetList;
public:
	afx_msg void OnTimer(UINT_PTR nIDEvent);
    afx_msg void OnBnClickedGetTaskInfo();
    afx_msg void OnCbnSelchangeBoardsList();
    CString m_SelectedName;
    afx_msg void OnBnClickedStartAll();
    afx_msg void OnBnClickedStopAll();
    afx_msg void OnBnClickedAbortAll();
    afx_msg void OnBnClickedSetAlpha();
    //afx_msg void OnCbnSelchangeTargetList();
    void FillBoardList( int sel );
	afx_msg void OnBnClickedShowProperties();
    afx_msg void OnLbnDblclkObjectsList();
    afx_msg void OnBnClickedStartStop();
    afx_msg void OnBnClickedCreateLog();
    afx_msg void OnCbnSelchangeZorder();
    afx_msg void OnBnClickedSuppressWarning();
    void SuppressWarning();
    afx_msg void OnCbnSelchangeIgnoreCancel();
    afx_msg void OnBnClickedTest();
    afx_msg void OnBnClickedDebugScriptEnable();
	afx_msg void OnBnClickedEditNotify();
	afx_msg void OnBnClickedSendNotify();

    static CString FormatNotify(CString notifyFile, double currTime, double notifyDuration, CString comments ) 
    {
        CString notifyStr;
        CString durationStr = ConvertDoubleToHHMMSSMS(notifyDuration);
        notifyStr.Format(_T("<titletime start=\"%1.03f\" crossfade=\"0.1\" />\r\n<movie file=\"%s\" crossfade=\"0.10\" duration=\"%s\" file_duration=\"%s\" />\r\n"), 
            currTime, (LPCTSTR)notifyFile, (LPCTSTR)durationStr, (LPCTSTR)durationStr);
        int currPos = 0;
        int i = 0;
        CString token = comments.Tokenize(_T("\r\n"), currPos);
        while (!token.IsEmpty()) {
            token.Trim(_T("\r\n"));
            token.Trim();
            if (!token.IsEmpty()) {
                if (token.Find(_T("after")) == 0) {
                    notifyStr.AppendFormat(_T("<after />\r\n"), token);
                }
                else {
                    notifyStr.AppendFormat(_T("<comment title=\"%s\" />\r\n"), token);
                }
            }
            token = comments.Tokenize(_T("\r\n"), currPos);
        }
        return notifyStr;
    }

    afx_msg void OnBnClickedCheckNotify();
    afx_msg void OnBnClickedSendNotifyLive();
    static CString ConvertDoubleToHHMMSSMS(double duration) {
        long ms = long((fmod(duration, 1) + 0.0001)* 1000); 
        long dur = (long)duration;
        long ss = dur % 60; dur /= 60;
        long mm = dur % 60; dur /= 60;
        long hh = dur % 60; dur /= 60;
        CString str;
        //str.Format(_T("%d:%02d:%02d.%02d"), hh, mm, ss, fr);
        str.Format(_T("%d:%02d:%02d.%03d"), hh, mm, ss, ms);
        return str;
    }
    //CString m_notifyStatus;

    // fd300 boards
    //long m_fd300BoardCount;
    //long m_fd300TargetCount;
    //long GetFD300BoardCount();
	struct CEngine
	{
	private:
		CString		_name;
		GUID		_guid;
		int			_index;
	public:
		CEngine()
			:_name(_T(""))
			, _guid(GUID_NULL)
			, _index(-1)
		{}
		CEngine(LPCTSTR name, GUID guid, int index)
			:_name(name)
			, _guid(guid)
			, _index(index)
		{}
		CEngine(CEngine& from)
			:_name(from._name)
			, _guid(from._guid)
			, _index(from._index)
		{}
		LPCTSTR Name() { return _name; }
		GUID Guid() { return _guid; }
		int	Index() { return _index; }
	};
	size_t m_currEngine;
	CArray<CEngine> m_engines;
    CComboBox m_Lang;
    afx_msg void OnCbnSelchangeLang();
    CString m_currLang;
    afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
    afx_msg void OnBnClickedCheckMute();
	CButton m_LoadAsDll;
	BOOL m_dll;
	afx_msg void OnBnClickedBoom();
	afx_msg void OnBnClickedBoom2();
	afx_msg void OnBnClickedFlipFlop();
	bool CheckPreload();
};
