
// FDExtRenderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FDExtRender.h"
#include "FDExtRenderDlg.h"
#define _USE_MATH_DEFINES 
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CFDExtRenderDlg dialog




CFDExtRenderDlg::CFDExtRenderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFDExtRenderDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pFieldImage = NULL;
	m_pAudioData = NULL;
}

void CFDExtRenderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DEVICE, m_DeviceList);
	DDX_Control(pDX, IDC_INFO, m_Info);
}

BEGIN_MESSAGE_MAP(CFDExtRenderDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &CFDExtRenderDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &CFDExtRenderDlg::OnBnClickedStop)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CFDExtRenderDlg message handlers

BOOL CFDExtRenderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	if( Init() != S_OK ) {
		EndDialog(IDCANCEL);
	}
	m_DeviceList.SetCurSel(0);
	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFDExtRenderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFDExtRenderDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFDExtRenderDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CFDExtRenderDlg::OnBnClickedStart()
{
	if( Start()==S_OK ) {
		GetDlgItem(IDC_STOP)->EnableWindow(TRUE);
		GetDlgItem(IDC_START)->EnableWindow(FALSE);
	} else  Stop();
}

void CFDExtRenderDlg::OnBnClickedStop()
{
	Stop();
	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
}

void CFDExtRenderDlg::OnTimer(UINT_PTR nIDEvent)
{
	static bool s_bInTimer = false;
	if( !s_bInTimer ) {
		s_bInTimer = true;
		for( int i=0; i<10; i++ ) if( RenderFrame() != S_OK )  break;
		s_bInTimer = false;
	}
	CDialog::OnTimer(nIDEvent);
}

//
// -------------- FDExtSrvd usage -------------
//
HRESULT CFDExtRenderDlg::Init()
{
	// clear all
	m_nRenderCnt = 0;
	m_pIPlayer = NULL;
	m_pIMgr = NULL;
	// create FDExt manager
	HRESULT hres = m_pIMgr.CoCreateInstance(FDExtSrvdLib::CLSID_FDExtMgr);
	ATLASSERT(hres==S_OK);
	// scan all valid renderers
	long nCnt = 0;
	hres = m_pIMgr->get_FDObjectsCount(&nCnt);
	ATLASSERT(hres==S_OK);
	for( long nIndex=0; nIndex < nCnt; nIndex++ ) {
		FDExtSrvdLib::CFDObjectInfo info;
		hres = m_pIMgr->get_FDObjectInfoByIndex(nIndex,&info);
		ATLASSERT(hres==S_OK);
		if( info.m_FDObjType==FDExtSrvdLib::FDObjType_VideoOut && info.m_Valid==TRUE ) {
			// it is a valid renderer - use the device
			m_nRenderID[m_nRenderCnt++] = nIndex;
			CString sName = CString((WCHAR*)info.m_BoardName) + CString(_T(" ")) + CString((WCHAR*)info.m_FDObjFriendlyName);;
			m_DeviceList.AddString(sName);
		}
	}
	if( m_nRenderCnt==0 ) { // no devices - show warning message
		MessageBox(_T("There is no video renderer!\n\nTurn off 'Title mixer' and try again"));
		return S_FALSE;
	}
	return S_OK;
}

HRESULT CFDExtRenderDlg::Start()
{
	m_nDropFrames = 0;
	m_Info.SetWindowText(_T("No drops"));
	// open video player by index
	int n = m_DeviceList.GetCurSel();
	ATLASSERT(n >= 0 && n < m_nRenderCnt);
	CComPtr<IUnknown> pIUnk;
	HRESULT hres = m_pIMgr->get_FDObjectByIndex(m_nRenderID[n], FDExtSrvdLib::FDObjType_VideoOut, &pIUnk);
	ATLASSERT(hres==S_OK);
	hres = pIUnk->QueryInterface(&m_pIPlayer);
	ATLASSERT(hres==S_OK);
	// obtain video info of the player
	FDExtSrvdLib::CBoardVideoParams vinfo;
	hres = m_pIPlayer->FDGetVideoParams(&vinfo);
	ATLASSERT(hres==S_OK);
	m_bUpperFieldFirst = vinfo.m_UpperFirst != 0;
	m_nDX = vinfo.m_DX;
	m_nDY = vinfo.m_DY/2;
	// create buffer for one field image in UYVY format
	if( m_pFieldImage != NULL )  delete[] m_pFieldImage;
	m_pFieldImage = new BYTE[vinfo.m_DX * vinfo.m_DY * 2];
	ATLASSERT(m_pFieldImage != NULL);
	// we will generate moving black & white stripe, reset stripe position
	m_nOffset = 0;
	// obtain audio info
	FDExtSrvdLib::CBoardSoundParams ainfo;
	hres = m_pIPlayer->FDGetSoundParams(&ainfo);
	ATLASSERT(hres==S_OK);
	// we will play audio from prerender audio buffer with 2 seconds of sin()
	m_fSamplePerFrame = (double)ainfo.m_SampleRate / ainfo.m_FrameRate;
	m_nSampleSize = ainfo.m_Channels * 2;
	m_nSampleAlign = ainfo.m_SampleRate;
	m_nChMask = 0;
	for( int i=0; i<ainfo.m_Channels; i++ )  m_nChMask |= 1<<i;
	// allocate 2 seconds audio data in 16 bit format
	if( m_pAudioData != NULL )  delete[] m_pAudioData;
	m_pAudioData = new short[ainfo.m_SampleRate * ainfo.m_Channels * 2];
	ATLASSERT(m_pAudioData != NULL);
	// reset audio playback position
	m_nLocalFrameIndex = 0; // local frame index (starting from zero)
	// fill 2 seconds of audio data by sin(400Hz)
	int nFreq = 400;
	int nPeriod = ainfo.m_SampleRate / nFreq;
	short *ptr = m_pAudioData;
	for( int i=0; i<nPeriod; i++ ) {
		short v = (short)(0x7FFF * sin(M_PI * (2*i) / nPeriod));
		for( int i=0; i<ainfo.m_Channels; i++ )  *ptr++ = v;
	}
	for( int i=1; i<nFreq*2; i++ )  CopyMemory(&m_pAudioData[i*nPeriod*ainfo.m_Channels], m_pAudioData, nPeriod*ainfo.m_Channels*2);
	// obtain current time
	DWORD64 tmp;
	hres = m_pIPlayer->FDGetBoardTime(&m_nFrameIndex,&tmp);
	ATLASSERT(hres==S_OK);
	// start render 4 frames later
	m_nFrameIndex += 4;
	// render 3 frames
	RenderFrame();
	RenderFrame();
	RenderFrame();
	// start playback
	SetTimer(101,10,NULL);
	return S_OK;
}

HRESULT CFDExtRenderDlg::Stop()
{
	KillTimer(101);
	m_pIPlayer = NULL;
	if( m_pFieldImage != NULL ) {
		delete[] m_pFieldImage;  
		m_pFieldImage = NULL; 
	}
	if( m_pAudioData != NULL ) {
		delete[] m_pAudioData;
		m_pAudioData = NULL;
	}
	return S_OK;
}

HRESULT CFDExtRenderDlg::RenderFrame()
{
	// check current time
	DWORD64 nFrame,tmp;
	HRESULT hres = m_pIPlayer->FDGetBoardTime(&nFrame,&tmp);
	ATLASSERT(hres==S_OK);
	if( m_nFrameIndex > nFrame+3 ) // fifo is full - wait
		return S_FALSE;
	if( nFrame+1 > m_nFrameIndex ) { // fifo underrun !!! skip frames
		long nSkip = (long)(nFrame+2 - m_nFrameIndex);
		m_nFrameIndex += nSkip;
		m_nLocalFrameIndex += nSkip;
		m_nDropFrames += nSkip;
		CString str;
		str.Format(_T("Drop %d frames"),m_nDropFrames);
		m_Info.SetWindowText(str);
	}
	hres = m_pIPlayer->FDAllocateVideoFrame(m_nFrameIndex,0);
	if( hres != S_OK )  return hres;
	// fill audio
	DWORD64 nCurAudioSample = (DWORD64)(m_fSamplePerFrame*m_nLocalFrameIndex + 0.5);
	DWORD64 nNextAudioSample = (DWORD64)(m_fSamplePerFrame*(m_nLocalFrameIndex+1) + 0.5);
	long size = (long)(nNextAudioSample - nCurAudioSample) * m_nSampleSize;
	long offset = (nCurAudioSample % m_nSampleAlign) * m_nSampleSize;
	// copy audio into fifo
	hres = m_pIPlayer->FDWriteSoundData((BYTE*)&m_pAudioData[offset],size, FDExtSrvdLib::FDCaptureSoundFormat_16bit, m_nChMask);
	ATLASSERT(hres==S_OK);
	// fill video
	long pos = (long)(m_nLocalFrameIndex % (m_nDX/2)) * 2;
	FillField(m_bUpperFieldFirst ? TRUE : FALSE, pos);
	FillField(m_bUpperFieldFirst ? FALSE : TRUE, pos+1);
	// mark frame as ready
	hres = m_pIPlayer->FDConfirmFrame();
	if( hres==S_FALSE ) // current frame already played - try again new one
		return S_OK;
	ATLASSERT(hres==S_OK);
	// goto next frame
	m_nLocalFrameIndex++;
	m_nFrameIndex++;
	return S_OK;
}

HRESULT CFDExtRenderDlg::FillField(BOOL bUpperField, long offset)
{
	// fill image
	BYTE *ptr = m_pFieldImage;
	for( int x=0; x<m_nDX; x++ ) {
		ptr[x*2+0] = 0x80; // U/V
		ptr[x*2+1] = x < offset ? 16 : 235; // Y
	}
	int stride = m_nDX*2;
	for( int y=1; y<m_nDY; y++ ) {
		ptr += stride;
		CopyMemory(ptr,m_pFieldImage,stride);
	}
	// copy video into fifo
	HRESULT hres = m_pIPlayer->FDWriteVideoFieldData(m_pFieldImage,stride*m_nDY,stride, FDExtSrvdLib::FDCaptureVideoFormat_UYVY, bUpperField);
	ATLASSERT(hres==S_OK);
	return S_OK;
}
