﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace SLStreamerPro.PropertyGrid
{
    class ObjectCategory : CollectionBase
    {
        string text;
        string id;

        public ObjectCategory(string id, string text)
        {
            this.text = text;
            this.id = id;
        }

        public void Add(ObjectProperty Value)
        {
            base.List.Add(Value);
        }

        public void Remove(string name)
        {
            foreach (object objProperty in base.List)
            {
                ObjectProperty property = objProperty as ObjectProperty;
                if (property != null && string.Compare(property.Id, name, true) == 0)
                {
                    base.List.Remove(property);
                    return;
                }
            }
        }

        public string Text
        {
            get { return text; }
        }

        public string Id
        {
            get { return id; }
        }

        public ObjectProperty this[int index]
        {
            get { return base.List[index] as ObjectProperty; }
            set { base.List[index] = value as ObjectProperty; }
        }
    }
}
