
// SLTitleTCPrinterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SLTitleTCPrinter.h"
#include "SLTitleTCPrinterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

extern "C" const GUID CLSID_SLDirectShowTitleEngine = {0x73DA552F,0x4946,0x4670,{0x84,0x84,0x95,0x8F,0x97,0xA2,0x23,0xF2}};

extern "C" const GUID CLSID_SLTMTitleServerTargetMgr = {0xDD02FC80,0x7D6E,0x440B,{0xBF,0x32,0x1A,0x29,0x77,0x4D,0xDC,0x1A}};
extern "C" const GUID CLSID_SLTMTitleNoPremultServerTargetMgr = {0xABCCE56A,0xC309,0x4FC8,{0x93,0x71,0x0F,0x58,0xCB,0xAA,0xAC,0x68}};
extern "C" const GUID CLSID_SLTMTitleArtServerTargetMgr = {0x4ACF2000,0x688A,0x4CFE,{0xB5,0x24,0x1A,0xFB,0x65,0x71,0x36,0xAB}};
extern "C" const GUID CLSID_SLTMTitleBackServerTargetMgr = {0xBB94349B,0xD939,0x459F,{0x80,0xD7,0x12,0xAF,0x07,0x26,0xAA,0xCB}};
extern "C" const GUID CLSID_SLTMTitleCTV1ServerTargetMgr = {0xC23977FA,0x73AA,0x46f9,{0x9F,0xCF,0xA6,0x89,0x53,0xF2,0xD7,0x08}};
extern "C" const GUID CLSID_SLTMTitleCTV2ServerTargetMgr = {0xA604A024,0x60F4,0x4674,{0xA7,0x6E,0x3D,0x42,0x29,0xC4,0x0D,0xA0}};

extern "C" const GUID CLSID_DVMTitleTargetMgr = {0xCA5260BE,0x10C2,0x438A,{ 0xB5,0xA5,0x94,0x23,0x7C,0x05,0x83,0x17}};

extern "C" const GUID CLSID_FDExtTitleFilterMgr = {0xBAFE501E,0x4874,0x4EF9,{0x8E,0xF3,0x22,0xD8,0xF3,0x97,0xDC,0x82}};

struct TEInfo {
	TCHAR *szNameTE;
	GUID guidTE;
};
const int eTEMaxNumber = 4;
struct TEInfo eTEList[eTEMaxNumber] = {
	{ _T("FDExt"), CLSID_FDExtTitleFilterMgr },
	{ _T("Videoprocessor"), CLSID_SLDirectShowTitleEngine },
	{ _T("FD300"), CLSID_SLTMTitleServerTargetMgr },
	{ _T("FD300 (external mixer)"), CLSID_SLTMTitleNoPremultServerTargetMgr }
};

// CSLTitleTCPrinterDlg dialog
CSLTitleTCPrinterDlg::CSLTitleTCPrinterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSLTitleTCPrinterDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bInTimer = false;
	m_nMaxValidIndex = 0;
}

void CSLTitleTCPrinterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TE_TYPE, TEType);
	DDX_Control(pDX, IDC_TE_INDEX, TEIndex);
	DDX_Control(pDX, IDC_START, btnStart);
	DDX_Control(pDX, IDC_STOP, btnStop);
	DDX_Control(pDX, IDC_FRAME_NUMBER, FrameNumber);
}

BEGIN_MESSAGE_MAP(CSLTitleTCPrinterDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_START, &CSLTitleTCPrinterDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &CSLTitleTCPrinterDlg::OnBnClickedStop)
	ON_CBN_SELCHANGE(IDC_TE_TYPE, &CSLTitleTCPrinterDlg::OnCbnSelchangeTeType)
END_MESSAGE_MAP()

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CSLTitleTCPrinterDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSLTitleTCPrinterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// CSLTitleTCPrinterDlg message handlers
BOOL CSLTitleTCPrinterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	for( int i=0; i<eTEMaxNumber; i++ )  TEType.AddString(eTEList[i].szNameTE);
	TEType.SetCurSel(-1);
	TEIndex.SetCurSel(-1);
	btnStart.EnableWindow(FALSE);
	btnStop.EnableWindow(FALSE);
	FrameNumber.SetWindowText(_T(""));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSLTitleTCPrinterDlg::OnDestroy()
{
	CDialog::OnDestroy();
	ReleaseRender();
}

void CSLTitleTCPrinterDlg::OnCbnSelchangeTeType()
{
	int n = TEType.GetCurSel();
	TEIndex.ResetContent();
	m_nMaxValidIndex = 0;
	// scan all valid devices
	CComPtr<ISLTitleServerTargetMgr> pIMgr;
	HRESULT hres = pIMgr.CoCreateInstance(eTEList[n].guidTE);
	if( hres != S_OK ) {
		CString str;  str.Format(_T("Can not create selected title engine manager, hres=0x%X"),hres);
		MessageBox(str,_T("SLTitleTCPrinter::InitTEMgr"));
		TEType.SetCurSel(-1);
	}
	long cnt = 0;
	pIMgr->get_TargetsCount(&cnt);
	CComQIPtr<ISLTitleServerTargetMgrExt> pIMgrExt(pIMgr);
	if( pIMgrExt != NULL ) for( long i=0; i<cnt; i++ ) {
		char valid = 0;
		CComBSTR bstr;
		hres = pIMgrExt->get_TargetInfoByIndex2(i,0,&bstr,&valid);
		if( valid != 0 ) {
			CString str(bstr);
			TEIndex.AddString(str);
			m_nValidIndex[m_nMaxValidIndex++] = i;
		}
	} else for( long i=0; i<cnt; i++ ) {
		CComPtr<IUnknown> pIUnk;
		hres = pIMgr->get_TargetByIndex(i, &pIUnk);
		if( hres==S_OK && pIUnk != NULL ) {
			CString str;  str.Format(_T("#%d"),i+1);
			TEIndex.AddString(str);
			m_nValidIndex[m_nMaxValidIndex++] = i;
		}
	}
	btnStart.EnableWindow(m_nMaxValidIndex > 0 ? TRUE : FALSE);
	if( m_nMaxValidIndex > 0 )  TEIndex.SetCurSel(0);
	else {
		MessageBox(_T("There is no one title engine for selected type"),_T("SLTitleTCPrinter::InitTEMgr"));
		TEType.SetCurSel(-1);
	}
}

void CSLTitleTCPrinterDlg::OnBnClickedStart()
{
	int step = 0;
	HRESULT hres = InitRender(TEType.GetCurSel(), TEIndex.GetCurSel(), step);
	if( hres==S_OK ) {
		TEType.EnableWindow(FALSE);
		TEIndex.EnableWindow(FALSE);
		btnStart.EnableWindow(FALSE);
		btnStop.EnableWindow(TRUE);
	} else {
		CString str;  str.Format(_T("Error on step %d, hres=0x%X"),step,hres);
		MessageBox(str,_T("SLTitleTCPrinter::Init"));
	}
}

void CSLTitleTCPrinterDlg::OnBnClickedStop()
{
	ReleaseRender();
	TEType.EnableWindow(TRUE);
	TEIndex.EnableWindow(TRUE);
	btnStart.EnableWindow(TRUE);
	btnStop.EnableWindow(FALSE);
	FrameNumber.SetWindowText(_T(""));
}

void CSLTitleTCPrinterDlg::OnTimer(UINT_PTR nIDEvent)
{
	if( !m_bInTimer ) {
		m_bInTimer = true;
		while( true ) {
			int step=0;
			HRESULT hres = DrawTimeCode(step);
			if( hres==S_FALSE )  break;
			else if( hres != S_OK ) {
				CString str;  str.Format(_T("Error on step %d, hres=0x%X"),step,hres);
				MessageBox(str,_T("SLTitleTCPrinter::DrawTimeCode"));
			}
		}
		m_bInTimer = false;
	}
	CDialog::OnTimer(nIDEvent);
}


HRESULT CSLTitleTCPrinterDlg::InitRender(int nTEType, int nValidIndex, int &step)
{
	step = 1;
	// obtain screen size
	CComPtr<ISLTitleTarget> pITitleTarget;
	HRESULT hres = pITitleTarget.CoCreateInstance(CLSID_SLTitleTarget);
	if( hres != S_OK )  return hres;
	step = 2;
	hres = pITitleTarget->ConnectLocalHost(&eTEList[nTEType].guidTE, m_nValidIndex[nValidIndex]);
	if( hres != S_OK )  return hres;
	step = 3;
	CComQIPtr<ISLTitleSurface> pISurface(pITitleTarget);
	if( pISurface==NULL )  return E_FAIL;
	// create resource holder
	step = 4;
	hres = m_pIHolder.CoCreateInstance(CLSID_SLResourceHolder);
	if( hres != S_OK )  return hres;
	// create region
	step = 5;
	CComPtr<IUnknown> pIUnk;
	hres = pISurface->CreateTitleRectRegion(m_pIHolder, 100*eDX*eDY*4, 95*eDX*eDY*4, &pIUnk);
	if( hres != S_OK )  return hres;
	step = 6;
	pIUnk.QueryInterface(&m_pIRegion);
	if( m_pIRegion==NULL )  return E_FAIL;
	// fill region info
	step = 7;
	CRegionInfo region_info;
	region_info.x0 = 0;
	region_info.y0 = 0;
	region_info.z = eZ;
	region_info.ShowLastHalfShot = FALSE;
	region_info.CurrShot = 0;
	region_info.x1 = eDX;
	region_info.y1 = eDY;
	region_info.alfa = 255;
	// set region parameters as full-screen object
	CSLTitleRegionPlacementFlds set_bits = (CSLTitleRegionPlacementFlds)(SLTRG_XYPosition | SLTRG_ZOrder | SLTRG_Alfa | SLTRG_ShowLastHalfShot | SLTRG_CurrShot);
	CSLTitleRegionPlacementFlds return_bits = (CSLTitleRegionPlacementFlds)0;
	hres = m_pIRegion->SetParameters(set_bits, &return_bits, &region_info);
	if( hres != S_OK )  return hres;
	// set region name
	CComQIPtr<ISLTitleRegionName> pIName(m_pIRegion);
	if( pIName != NULL )  pIName->SetTitleRegionName(CComBSTR(_T("SLTitleTCPrinter")));
	// calc start frame
	step = 8;
	hres = m_pIRegion->GetParameters(&region_info);
	if( hres != S_OK )  return hres;
	m_nStartGlobalShot = region_info.GlobalShot + 15;
	// activate region
	step = 9;
	hres = m_pIRegion->SetActive(TRUE,TRUE,m_nStartGlobalShot);
	if( hres != S_OK )  return hres;
	// start timer
	step = 10;
	m_nCurShot = 0;
	m_bInTimer = false;
	SetTimer(eTimer, 10, NULL);
	return S_OK;
}

void CSLTitleTCPrinterDlg::ReleaseRender()
{
	KillTimer(eTimer);
	if( m_pIRegion != NULL ) {
		m_pIRegion->SetActive(FALSE,FALSE,0);
		Sleep(100);
	}
	m_pIRegion = NULL;
	m_pIHolder = NULL;
}

HRESULT CSLTitleTCPrinterDlg::DrawTimeCode(int &step)
{
	step = 101;
	CString szTimeCode;
	szTimeCode.Format(_T("%d"), m_nStartGlobalShot + m_nCurShot);
	// obtain buffer for image
	BYTE *pData = NULL;
	DWORD nSize = eDY*eDX*4;
	HRESULT hres = m_pIRegion->GetShotBuff(nSize,nSize,&pData,&nSize,0);
	step = 102;
	if( hres != S_OK )  return hres;
	step = 103;
	if( nSize != (DWORD)eDY*eDX*4 )  return E_FAIL;
	BITMAPINFOHEADER bmpi;  ZeroMemory(&bmpi,sizeof(bmpi));
	bmpi.biSize = sizeof(bmpi);
	bmpi.biPlanes = 1;
	bmpi.biBitCount = 32;
	bmpi.biHeight = eDY;
	bmpi.biWidth = eDX;
	bmpi.biSizeImage = nSize;
	// draw text
	CRect rc(0,0,eDX,eDY);  CDC dc;  dc.CreateCompatibleDC(NULL);
	CBitmap bitmap;  bitmap.CreateCompatibleBitmap(&dc,eDX,eDY);
	CFont font1;  font1.CreatePointFont(-256,_T("Arial Bold"));
	dc.SetBkColor(RGB(0,0,128));
	dc.SetTextColor(RGB(0,255,64));
	CBitmap *oldBitmap = dc.SelectObject(&bitmap);
	CFont *oldFont = dc.SelectObject(&font1);
	dc.DrawText(szTimeCode, rc, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
	GetDIBits(dc, bitmap, 0,eDY, pData,(BITMAPINFO*)&bmpi,DIB_RGB_COLORS);
	dc.SelectObject(oldFont);
	dc.SelectObject(oldBitmap);
	// flip vertically & fill alpha by G or by 255
	int stride = eDX*4;
	BYTE *ptr1 = &pData[0];
	BYTE *ptr2 = &pData[(eDY-1)*stride];
	for( int y=0; y<eDY/2; y++ ) { // fill Alpha by 0xFF
		for( int x=0; x<eDX; x++ ) {
			register BYTE g1 = ptr1[x*4+1];
			register BYTE g2 = ptr2[x*4+1];
			ptr2[x*4+0] = g1/2; // B (lower half-image)
			ptr2[x*4+1] = g1;   // G
			ptr2[x*4+2] = 0;    // R
			ptr2[x*4+3] = 0xFF; // A
			ptr1[x*4+0] = g2/2; // B (upper half-image)
			ptr1[x*4+1] = g2;   // G
			ptr1[x*4+2] = 0;    // R
			ptr1[x*4+3] = 0xFF; // A
		}
		ptr1 += stride;
		ptr2 -= stride;
	}
	// draw image
	CTitleShotInfo shot_info;
	shot_info.DataType = TitleShotDataType_BGRA;
	shot_info.dx = eDX;
	shot_info.dy = eDY;
	shot_info.ShotNumber = m_nCurShot;
	hres = m_pIRegion->ConfirmShotSize(0,nSize,&shot_info);
	step = 104;
	if( hres != S_OK )  return hres;
	// all right
	m_nCurShot++;
	FrameNumber.SetWindowText(szTimeCode);
	step = 109;
	return S_OK;
}
