// MainDlg.cpp : implementation of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "aboutdlg.h"
#include "MainDlg.h"


BOOL CMainDlg::PreTranslateMessage(MSG* pMsg)
{
	return CWindow::IsDialogMessage(pMsg);
}

BOOL CMainDlg::OnIdle()
{
	return FALSE;
}

LRESULT CMainDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	// add About menu item
	HANDLE hSysMenu = GetSystemMenu(FALSE);
	::AppendMenu((HMENU)hSysMenu, MF_SEPARATOR, NULL, NULL);
	::AppendMenu((HMENU)hSysMenu, MF_STRING, ID_APP_ABOUT, _T("About SMSChatClient...") );

	// center the dialog on the screen
	CenterWindow();

	// set icons
	HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
		IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
	SetIcon(hIcon, TRUE);
	HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
		IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
	SetIcon(hIconSmall, FALSE);

	// register object for message filtering and idle updates
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	ATLASSERT(pLoop != NULL);
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);

	UIAddChildWindowContainer(m_hWnd);

	m_sWindowTitle = _T("SMSChatClient - ");

	m_pcoSMSCallBack = NULL;

	m_spISMSObjectsManager = NULL;
	if (FAILED(m_spISMSObjectsManager.CoCreateInstance(CLSID_SMSObjectsManager)))
		MessageBox(_T("Can't create instance of Chat Manager"), _T("Error"), MB_OK|MB_ICONERROR);

	//CComboBox cbComboBox = GetDlgItem(IDC_COMBO_SMS_OBJECTS_LIST);
	//cbComboBox.SetWindowText(_T("Select..."));

	CWindow bn2;
	bn2 = GetDlgItem(IDC_BUTTON_SET_MSG_STRING);
	bn2.EnableWindow(FALSE);

	CWindow ed2;
	ed2 = GetDlgItem(IDC_EDIT_MSG_STRING);
	ed2.EnableWindow(FALSE);

	m_sSMSObjectName = _T("");
	m_nStyleIndex = 0;
	m_nMessageID = 0;
	m_nShownMsgID = 0;
	DoDataExchange(FALSE);

	SetWindowText(m_sWindowTitle + CString(_T("Not Connected")));
	return TRUE;
}

LRESULT CMainDlg::OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled = FALSE;
	UINT cmd = (UINT)wParam;
	if (cmd == ID_APP_ABOUT) {
		CAboutDlg AboutDlg;
		AboutDlg.DoModal();
	}
	return 0;
}

LRESULT CMainDlg::OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CAboutDlg dlg;
	dlg.DoModal();
	return 0;
}

LRESULT CMainDlg::OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	return 0;
}

LRESULT CMainDlg::OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CloseDialog(wID);
	return 0;
}

void CMainDlg::CloseDialog(int nVal)
{
	m_spISMSObject = NULL;
	m_spISMSObjectsManager = NULL;
	if (m_pcoSMSCallBack != NULL) {
		m_pcoSMSCallBack->Release();
		m_pcoSMSCallBack = NULL;
	}
	DestroyWindow();
	::PostQuitMessage(nVal);
}

LRESULT CMainDlg::OnBnClickedGetSMSObject(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	DoDataExchange(TRUE);

	if (m_sSMSObjectName.IsEmpty()) 
		return 0;

	CWindow bn2;
	bn2 = GetDlgItem(IDC_BUTTON_SET_MSG_STRING);
	CWindow ed2;
	ed2 = GetDlgItem(IDC_EDIT_MSG_STRING);

	HRESULT hr = S_OK;
	CComPtr <IUnknown> spIUnk;

	if (m_spISMSObject != NULL)
		m_spISMSObject->UnAdvise();
	m_spISMSObject = NULL;

	if (m_pcoSMSCallBack != NULL)
		m_pcoSMSCallBack->Release();
	m_pcoSMSCallBack = NULL;

	hr = m_spISMSObjectsManager->GetSMSObjectByName(CComBSTR(m_sSMSObjectName), &spIUnk);
	if (FAILED(hr))
	{
		CString msg;
		msg.Format(_T("Failed to connect to object with name '%s'"), m_sSMSObjectName);
		MessageBox(msg, _T("Error!"), MB_OK|MB_ICONERROR);
		bn2.EnableWindow(FALSE);
		ed2.EnableWindow(FALSE);
		return 0;
	}

	m_spISMSObject = spIUnk;
	if (m_spISMSObject == NULL)
	{
		MessageBox(_T("Failed to retrieve ISMSObject interface."), _T("Error!"), MB_ICONERROR|MB_OK);
		bn2.EnableWindow(FALSE);
		ed2.EnableWindow(FALSE);
		return 0;
	}
	hr = m_spISMSObject->GetStyleCount(&m_nStyleCount);

	/// Advise to CallBack ///////////////////////
	hr = CComObject <CSMSCallBack>::CreateInstance(&m_pcoSMSCallBack);
	if (FAILED(hr))
	{
		MessageBox(_T("Failed to CreateInstance of local SMSCallBack object."), _T("Error!"), MB_ICONERROR|MB_OK);
		bn2.EnableWindow(FALSE);
		ed2.EnableWindow(FALSE);
		m_spISMSObject = NULL;
		m_pcoSMSCallBack = NULL;
		return 0;
	}

	m_pcoSMSCallBack->AddRef();
	m_pcoSMSCallBack->m_hwndMainDlg = m_hWnd; // pass MainWnd HWND to SMSCallback CoClass, to make it able to set ShownMsgID in edit control.

	spIUnk = NULL;

	hr = m_pcoSMSCallBack->QueryInterface(IID_IUnknown, (void**)&spIUnk);
	if (FAILED(hr))
	{
		MessageBox(_T("Failed to QueryInterface(IID_IUnknown) interface from local SMSCallBack object."), _T("Error!"), MB_ICONERROR|MB_OK);
		bn2.EnableWindow(FALSE);
		ed2.EnableWindow(FALSE);
		m_spISMSObject.Release();
		m_pcoSMSCallBack->Release();
		m_pcoSMSCallBack = NULL;
		return 0;
	}

	hr = m_spISMSObject->Advise(spIUnk);
	if (FAILED(hr))
	{
		MessageBox(_T("Failed to Advise to SMSCallBack object."), _T("Error!"), MB_ICONERROR|MB_OK);
		bn2.EnableWindow(FALSE);
		ed2.EnableWindow(FALSE);
		m_spISMSObject.Release();
		m_pcoSMSCallBack->Release();
		m_pcoSMSCallBack = NULL;
		return 0;
	}

	bn2.EnableWindow(TRUE);
	ed2.EnableWindow(TRUE);

	SetWindowText(m_sWindowTitle + m_sSMSObjectName);
	return 0;
}

LRESULT CMainDlg::OnBnClickedSetMsgString(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	DoDataExchange(TRUE);

	if (m_spISMSObject != NULL)
	{
		HRESULT hr = S_OK;
		FLOAT fFullness;

		//for ( m_nStyleIndex = 0; SUCCEEDED(hr) && m_nStyleIndex < m_nStyleCount; m_nStyleIndex++ )
		//{
		//	// TODO: SMS object Name
		//	hr = m_spISMSObject->TestMessage(CComBSTR(m_MessageString), NULL, m_nStyleIndex, m_nMessageID, &fFullness);
		//	if ( FAILED(hr) )
		//		break;
		//	if ( fFullness <= 1.0f )
		//		break;
		//}

		if ( SUCCEEDED(hr) )
		{
			// HACK: SMS object Name
			hr = m_spISMSObject->SetMessage(CComBSTR(m_MessageString), NULL, m_nStyleIndex, m_nMessageID);

			LPVOID pRes;
			::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
							NULL, hr, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&pRes, 0, NULL);

			CWindow ed3 = GetDlgItem(IDC_EDIT_RES);
			ed3.SetWindowText((LPTSTR)pRes);

			if ( SUCCEEDED(hr) )
			{
				m_MessageString.Empty();
				m_nMessageID++;
				DoDataExchange(FALSE);
			}
		}		
	}
	else
		MessageBox(_T("Not connected to SMS object"),_T("Error"));
			
	return 0;
}

LRESULT CMainDlg::OnComboElementsListDropDown(WORD wNotifyCode, WORD wID, HWND hWndCtl)
{
	HRESULT hr = S_OK;
	INT nObjectsCount = 0;
	CComboBox cbComboBox = GetDlgItem(IDC_COMBO_SMS_OBJECTS_LIST);
	INT nComboBoxCount = cbComboBox.GetCount();

	for (INT i = 0; i<nComboBoxCount; i++) {
		cbComboBox.DeleteString(0);
	}

	hr = m_spISMSObjectsManager->GetSMSObjectsCount(&nObjectsCount);
	if (FAILED(hr))	{
		MessageBox(_T("Failed to get SMS Objects count."),_T("Error"));
		return 0;
	}

	if (nObjectsCount == 0) {
		return 0;
	}

	for (INT i = 0; i < nObjectsCount; i++) {
		CComBSTR sName;
		hr = m_spISMSObjectsManager->GetSMSObjectName(i, &sName);
		if (FAILED(hr)) {
			CString msg;
			msg.Format(_T("Failed to get name of object with index '%d'"), i);
			MessageBox(msg, _T("Error!"), MB_OK|MB_ICONERROR);
		}else{
			cbComboBox.AddString(sName);
		}
	}
	return 0;
}


