// MainDlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once
#include <atlmisc.h>
#include <atlcrack.h>
#include <atlddx.h>

#include "SMSCallBack.h"

class CMainDlg : public CDialogImpl<CMainDlg>, public CUpdateUI<CMainDlg>,
	public CMessageFilter, public CIdleHandler,
	public CWinDataExchange<CMainDlg>
{
public:
	enum { IDD = IDD_MAINDLG };

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnIdle();

	BEGIN_UPDATE_UI_MAP(CMainDlg)
	END_UPDATE_UI_MAP()

	BEGIN_MSG_MAP(CMainDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_SYSCOMMAND, OnSysCommand)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_HANDLER(IDC_BUTTON_GET_SMS_OBJECT, BN_CLICKED, OnBnClickedGetSMSObject)
		COMMAND_HANDLER(IDC_BUTTON_SET_MSG_STRING, BN_CLICKED, OnBnClickedSetMsgString)
		COMMAND_HANDLER_EX(IDC_COMBO_SMS_OBJECTS_LIST, CBN_DROPDOWN, OnComboElementsListDropDown)
	END_MSG_MAP()

	BEGIN_DDX_MAP(CMainDlg)
		DDX_TEXT(IDC_EDIT_MSG_STRING, m_MessageString)
		DDX_UINT(IDC_EDIT_MSG_ID, m_nMessageID)
		DDX_INT_RANGE(IDC_EDIT_STYLE_INDEX, m_nStyleIndex, 0, 99999)
		DDX_TEXT(IDC_COMBO_SMS_OBJECTS_LIST, m_sSMSObjectName)
		DDX_UINT(IDC_EDIT_SHOWN_MSG_ID, m_nShownMsgID)
	END_DDX_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnSysCommand(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/); 

	void CloseDialog(int nVal);

	CString m_sWindowTitle;
	CComObject <CSMSCallBack>* m_pcoSMSCallBack;
	CComPtr <ISMSObjectsManager> m_spISMSObjectsManager;
	CComPtr <ISMSObject> m_spISMSObject;
	LONG	m_nStyleCount;
	CString m_MessageString;
	INT m_nStyleIndex;
	UINT m_nMessageID;
	CString m_sSMSObjectName;
	UINT m_nShownMsgID;

public:
	LRESULT OnBnClickedGetSMSObject(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled );
	LRESULT OnBnClickedSetMsgString(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnComboElementsListDropDown(WORD wNotifyCode, WORD wID, HWND hWndCtl);
};
