// SMSCallBack.h : Declaration of the CSMSCallBack

#pragma once
#include "resource.h"       // main symbols

#include "SMSChatClient.h"

// CSMSCallBack

class ATL_NO_VTABLE CSMSCallBack : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSMSCallBack, &CLSID_SMSCallBack>,
	public IDispatchImpl<ISMSCallBack, &IID_ISMSCallBack, &LIBID_SMSObjMgrLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSMSCallBack()
		: m_pUnkMarshaler(NULL)
	{ }

	DECLARE_REGISTRY_RESOURCEID(IDR_SMSCALLBACK)

	DECLARE_NOT_AGGREGATABLE(CSMSCallBack)

	BEGIN_COM_MAP(CSMSCallBack)
		COM_INTERFACE_ENTRY(ISMSCallBack)
		COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
	END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

	// ISMSCallBack Methods
public:
	STDMETHOD(OnMessageShown)(long nMsgID)
	{
		if (m_hwndMainDlg)
		{
			CWindow edShownMsgID = ::GetDlgItem(m_hwndMainDlg, IDC_EDIT_SHOWN_MSG_ID);
			CString s;
			s.Format(_T("%d"), nMsgID);
			edShownMsgID.SetWindowText(s);
		}
		return S_OK;
	}

public:	
	HWND m_hwndMainDlg;
};

OBJECT_ENTRY_NON_CREATEABLE_EX_AUTO(__uuidof(SMSCallBack), CSMSCallBack)
//OBJECT_ENTRY_AUTO(__uuidof(SMSCallBack), CSMSCallBack)
