//#include "stdafx.h"


class CVersHolder
{
public:
	CVersHolder()
	{
		m_iAppVers = m_iSaveVers = m_iBuildVers1 = m_iBuildVers2 = 0;
	
		TCHAR sFileName[MAX_PATH];
		DWORD Size = ::GetModuleFileName(NULL, sFileName, MAX_PATH);

		if(0 != Size) 
		{
			if(!GetFileVersions(sFileName, m_iAppVers, m_iSaveVers, m_iBuildVers1, m_iBuildVers2))
			{
				m_iAppVers = m_iSaveVers = m_iBuildVers1 = m_iBuildVers2 = 0;
			}
		}
		
	}

	~CVersHolder(){}

	int GetCheckVersInt()
	{
		CString Text(_T(""));
		Text.Format(_T("%d%d%d%d"), m_iAppVers, m_iSaveVers, m_iBuildVers1, m_iBuildVers2);

		return _wtoi(Text);
	}

	CString GetVersStringTotal()
	{
		TCHAR sFileName[MAX_PATH];

		DWORD Size = ::GetModuleFileName(NULL, sFileName, MAX_PATH);

		if(0 == Size) return _T("");
		
		CString sName = CString(sFileName);

		int Index = sName.ReverseFind('\\');

		if(-1 == Index) return _T("");

		sName = sName.Right(sName.GetLength() - Index - 1);	

		Index = sName.Find('.');

		if(-1 == Index) return _T("");

		sName = sName.Left(Index);

		sName += _T(" ");
		sName += _T("Version " + GetVersString());

		return sName;
	}

	CString GetVersString()
	{
		CString Text(_T(""));
		Text.Format(_T("%d.%d.%d.%d"), m_iAppVers, m_iSaveVers, m_iBuildVers1, m_iBuildVers2);
	
		return Text;
	}

	BOOL GetFileVersions(CString file, int &v1, int &v2, int &v3, int &v4)
	{
		DWORD dwLen, dwUseless;
		LPTSTR lpVI;

		dwLen = GetFileVersionInfoSize((LPTSTR)file.GetBuffer(5), &dwUseless);

		if(dwLen==0) return FALSE;
	  
		lpVI = (LPTSTR) GlobalAlloc(GPTR, dwLen);

		if(lpVI)
		{
			DWORD dwBufSize;
			VS_FIXEDFILEINFO* lpFFI;

			GetFileVersionInfo(file.GetBuffer(5), NULL, dwLen, lpVI);

			if(VerQueryValue(lpVI, _T("\\"), (LPVOID *) &lpFFI, (UINT*) &dwBufSize))
			{
				v1 = HIWORD(lpFFI->dwFileVersionMS);
				v2 = LOWORD(lpFFI->dwFileVersionMS);
				v3 = HIWORD(lpFFI->dwFileVersionLS);
				v4 = LOWORD(lpFFI->dwFileVersionLS);
			}

			GlobalFree((HGLOBAL)lpVI);
		}

		return TRUE;
	}


private:
	int m_iAppVers;
	int m_iSaveVers;
	int m_iBuildVers1;
	int m_iBuildVers2;
};
