#include "StdAfx.h"
#include "ColorGenerator.h"

HRESULT CColorGenerator::DrawNextImage(RGBQUAD *ptr, long nFrameIndex)
{
	// --- fill image by color gradient with moving alpha ---
	// calc base alpha from current frame index
	BYTE alpha = (BYTE)m_nFrameIndex;
	// fill image
	for( int y=0; y<m_nDY; y++ ) {
		// calc base alpha for current line
		int a = alpha + y;
		for( int x=0; x<m_nDX; x++ ) {
			ptr[x].rgbBlue = x;			// interpolate BLUE horizontally
			ptr[x].rgbGreen = 0;		// no green
			ptr[x].rgbRed = y;			// interpolate red vertically
			ptr[x].rgbReserved = a++;	// interpolate alpha horizontally & vertically
		}
		// shift image pointer to next line
		ptr += m_nDX;
	}
	// image ready
	return S_OK;
}
