// TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include <process.h>

// include file 'TitleSDK\SLTitleSDK.h' before 'using namespace SLTMTitleRunTime;'
#include "ColorGenerator.h"
#include "CrawlGenerator.h"
// include file 'TitleSDK\SLTitleSDK_i.c' before 'using namespace SLTMTitleRunTime;'
#include "TitleSDK\SLTitleSDK_i.c"

#include "SLTMTitleRunTimeSDK.h"
#include "TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestDlg dialog



CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROJECT_NAME, m_cProjectName);
}

BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_PROJECT_BROWSE, OnBnClickedProjectBrowse)
	ON_BN_CLICKED(IDC_PROJECT_START, OnBnClickedProjectStart)
	ON_BN_CLICKED(IDC_PROJECT_STOP, OnBnClickedProjectStop)
	ON_BN_CLICKED(IDC_PROJECT_HIDE, OnBnClickedProjectHide)
	ON_BN_CLICKED(IDC_COLOR_START, OnBnClickedColorStart)
	ON_BN_CLICKED(IDC_COLOR_STOP, OnBnClickedColorStop)
	ON_BN_CLICKED(IDC_CRAWL_START, OnBnClickedCrawlStart)
	ON_BN_CLICKED(IDC_CRAWL_STOP, OnBnClickedCrawlStop)
END_MESSAGE_MAP()


// CTestDlg message handlers

BOOL CTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	if( !InitTitles() ) {
		ReleaseTitles();
		EndDialog(IDCANCEL);
		return FALSE;
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
}

void CTestDlg::OnDestroy()
{
	ReleaseTitles();
	CDialog::OnDestroy();
}

void CTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


///////////////////////////////////////////////////////////////////////////////
//
//  Tools
//
///////////////////////////////////////////////////////////////////////////////

CString FormatMessage(HRESULT hr)
{
	LPVOID lpMsgBuf;
	if (!::FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		hr,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL ))
	{
		// Handle the error.
		return CString(_T(""));
	}
	CString message = (LPCTSTR)lpMsgBuf;

	// Free the buffer.
	LocalFree( lpMsgBuf );

	return message;
}

void ErrMsgBox(HWND hwnd, LPCTSTR name, HRESULT hres, LPCTSTR text=NULL)
{
	CString str,msg;
	if( text==NULL )  msg = FormatMessage(hres);
	else  msg = text;
	str.Format(_T("ERROR on %s\nerror code = 0x%X\n%s"),name,hres,(LPCTSTR)msg);
	::MessageBox(hwnd,str,_T("TitleSDK Sample"),MB_ICONEXCLAMATION);
}

void ErrMsgBox(HWND hwnd, _com_error& err, LPCTSTR name)
{
	ErrMsgBox(hwnd, name, err.Error(), err.ErrorInfo()==NULL ? err.ErrorMessage() : err.Description());
}

///////////////////////////////////////////////////////////////////////////////
//
//  Hi-level Title SDK usage
//
///////////////////////////////////////////////////////////////////////////////

bool CTestDlg::InitTitles()
{
	HRESULT hres;
	// initialize COM
	hres = CoInitializeEx(NULL,COINIT_MULTITHREADED);
	if( FAILED(hres) ) {
		ErrMsgBox(m_hWnd, _T("CoInitializeEx"), hres);
		return false;
	}
	// create hi-level title manager
	hres = m_pIProject.CreateInstance(__uuidof(SLTMTitleRunTime::TitleProjectMgr));
	if( FAILED(hres) ) {
		ErrMsgBox(m_hWnd, _T("m_pIProject.CoCreateInstance"), hres);
		return false;
	}
	// create 'color generator'
	m_pColorGenerator = NULL;
	m_hColorGeneratorThread = NULL;
	// create 'crawl generator'
	m_pCrawlGenerator = NULL;
	m_hCrawlGeneratorThread = NULL;
	// all right
	return true;
}

void CTestDlg::ReleaseTitles()
{
	// stop all
	OnBnClickedProjectHide();
	OnBnClickedColorStop();
	OnBnClickedCrawlStop();

	// close all COM-objects
	m_pIProject = NULL;
	m_pColorGenerator = NULL;
	m_pCrawlGenerator = NULL;

	// unintialize COM
	CoUninitialize();
}

//
// Select and load title project for next playback
//
void CTestDlg::OnBnClickedProjectBrowse()
{
	// select title project file
	CFileDialog dlg(TRUE, _T(".SLTitleProj"), _T(""), 0, _T("Title Projects|*.SLTitleProj|"), this);
	if( dlg.DoModal()==IDOK ) {
		// convert the file name to BSTR
		_bstr_t bstrName(dlg.GetPathName());
		// load title project and open all title objects
		try {
			HRESULT hres = m_pIProject->Init(bstrName, CImageGenerator::nBoardIndex, &CImageGenerator::guidTitleTarget);
		} 
		catch(_com_error& err) {
			ErrMsgBox(m_hWnd, err, _T("InitProject"));
			m_cProjectName.SetWindowText(_T(""));
			return;
		}
		// write name for user
		m_cProjectName.SetWindowText(dlg.GetPathName());
	}
}

//
// Start playback of loaded title project
//
void CTestDlg::OnBnClickedProjectStart()
{
	try {
		// obtain title objects count
		long nCount = m_pIProject->NumObjects;
		if( nCount==0 )
		{
			// there is no objects - nothing to do
			return;
		}

		// --- obtain current time ---
		double fStartTime=0,tmp1;  long tmp2;
		// obtain run-time interface of first title object
		SLTMTitleRunTime::ISLTMTitleRunTime3Ptr pIObject = m_pIProject->GetRunTimeInterface(0);
		// obtain current time
		pIObject->GetPlayInfo(&fStartTime, &tmp1, &tmp1, &tmp2);
		// release first object
		pIObject = NULL;

		// shift start time to half second
		fStartTime += 0.5;
		// set 'fadeIn' duration to half seconf
		double fFadeIn = 0.5;
		
		// starts all title objects
		for( int i=0; i<nCount; i++ )
		{
			// obtain title object with index 'i'
			SLTMTitleRunTime::ISLTMTitleRunTime3Ptr pIObject = m_pIProject->GetRunTimeInterface(i);
			// start playback of the object at time 'fStartTime'
			pIObject->Start(fStartTime,fFadeIn);
			// release the object
			pIObject = NULL;
		}

	}
	catch(_com_error& err) {
		if( err.Error() != ProcessedHRES )
			ErrMsgBox(m_hWnd, err, _T("Start Playback"));
	}
}

//
// Stop playback of title project
//
void CTestDlg::OnBnClickedProjectStop()
{
	try {
		// obtain title objects count
		long nCount = m_pIProject->NumObjects;
		if( nCount==0 )
		{
			// there is no objects - nothing to do
			return;
		}

		// set finish time at one second after current time
		double fFinishTime = -1.0;
		// set 'fadeOut' duration to half seconf
		double fFadeOut = 0.5;
		
		// starts all title objects
		for( int i=0; i<nCount; i++ )
		{
			// obtain title object with index 'i'
			SLTMTitleRunTime::ISLTMTitleRunTime3Ptr pIObject = m_pIProject->GetRunTimeInterface(i);
			// start playback of the object at time 'fStartTime'
			pIObject->Stop(fFinishTime,fFadeOut);
			// release the object
			pIObject = NULL;
		}

	}
	catch(_com_error& err) {
		ErrMsgBox(m_hWnd, err, _T("Stop Playback"));
	}
}

//
// Abort playback of title project (hide all title objects)
//
void CTestDlg::OnBnClickedProjectHide()
{
	try {
		// obtain title objects count
		long nCount = m_pIProject->NumObjects;
		if( nCount==0 )
		{
			// there is no objects - nothing to do
			return;
		}

		// set empty 'fadeOut' duration
		double fFadeOut = 0.0;
		
		// starts all title objects
		for( int i=0; i<nCount; i++ )
		{
			// obtain title object with index 'i'
			SLTMTitleRunTime::ISLTMTitleRunTime3Ptr pIObject = m_pIProject->GetRunTimeInterface(i);
			// start playback of the object at time 'fStartTime'
			pIObject->Abort(fFadeOut);
			// release the object
			pIObject = NULL;
		}

	}
	catch(_com_error& err) {
		ErrMsgBox(m_hWnd, err, _T("Abort Playback"));
	}
}


///////////////////////////////////////////////////////////////////////////////
//
//  Low-level Title SDK usage
//
///////////////////////////////////////////////////////////////////////////////

unsigned int __stdcall WorkerThreadProc(void *ptr)
{
	CImageGenerator *generator = (CImageGenerator*)ptr;
	SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_ABOVE_NORMAL);
	generator->m_bNeedToWork = true;
	generator->Work();
	generator->m_bNeedToWork = false;
    _endthreadex( 0 );
    return 0;
}



void CTestDlg::OnBnClickedColorStart()
{
	if( m_pColorGenerator != NULL )  return;
	// create color generator object & init it
	m_pColorGenerator = new CColorGenerator();
	if( m_pColorGenerator==NULL )  return;
	// select working area & z-order
	RECT area;
	area.left = 16;
	area.top = 16;
	area.right = area.left + 256;
	area.bottom = area.top + 256;
	HRESULT hres = m_pColorGenerator->Init(area,11);
	if( FAILED(hres) ) {
		ErrMsgBox(m_hWnd, _T("Init Color Generator"), hres);
		return;
	}
	// start working thread
	unsigned thrdID;
	m_hColorGeneratorThread = (HANDLE)_beginthreadex( NULL, 0, WorkerThreadProc, m_pColorGenerator, 0, &thrdID );
	if( m_hColorGeneratorThread == NULL ) {
		ErrMsgBox(m_hWnd, _T("Start Color Generator Thread"), GetLastError());
		return;
	}
}

void CTestDlg::OnBnClickedColorStop()
{
	if( m_pColorGenerator == NULL )  return;
	// mark to stop
	m_pColorGenerator->m_bNeedToWork = false;
	// wait finish of the thread
	if( m_hColorGeneratorThread != NULL ) {
		// wait one second maximum
		WaitForSingleObject(m_hColorGeneratorThread, 5000);
		// close handle of the thread
		CloseHandle(m_hColorGeneratorThread);
		// clear handle for next usage
		m_hColorGeneratorThread = NULL;
	}
	// close the generator
	delete m_pColorGenerator;
	m_pColorGenerator = NULL;
}

void CTestDlg::OnBnClickedCrawlStart()
{
	if( m_pCrawlGenerator != NULL )  return;
	// create color generator object & init it
	m_pCrawlGenerator = new CCrawlGenerator();
	if( m_pCrawlGenerator==NULL )  return;
	// select working area & z-order
	RECT area;
	area.left = 0;
	area.top = 300;
	area.right = area.left + 720;
	area.bottom = area.top + 64;
	HRESULT hres = m_pCrawlGenerator->Init(area,12);
	if( FAILED(hres) ) {
		ErrMsgBox(m_hWnd, _T("Init Crawl Generator"), hres);
		return;
	}
	// start working thread
	unsigned thrdID;
	m_hCrawlGeneratorThread = (HANDLE)_beginthreadex( NULL, 0, WorkerThreadProc, m_pCrawlGenerator, 0, &thrdID );
	if( m_hCrawlGeneratorThread == NULL ) {
		ErrMsgBox(m_hWnd, _T("Start Crawl Generator Thread"), GetLastError());
		return;
	}
}

void CTestDlg::OnBnClickedCrawlStop()
{
	if( m_pCrawlGenerator == NULL )  return;
	// mark to stop
	m_pCrawlGenerator->m_bNeedToWork = false;
	// wait finish of the thread
	if( m_hCrawlGeneratorThread != NULL ) {
		// wait one second maximum
		WaitForSingleObject(m_hCrawlGeneratorThread, 5000);
		// close handle of the thread
		CloseHandle(m_hCrawlGeneratorThread);
		// clear handle for next usage
		m_hCrawlGeneratorThread = NULL;
	}
	// close the generator
	delete m_pCrawlGenerator;
	m_pCrawlGenerator = NULL;
}
